﻿var db = null; // varijabla za pristup bazi podataka
var callStack = ""; // čuva nazive prethodno prikazanih stranica
var pushNotification;
var screenHeight;
var selectedTransactionID = null;
var selectedNotificationID = null;
var selectedTemplateID = null;
var homePageDegree;
var homePageThread;
var homePageDateStart;
var homePageDateEnd;
var homePageDateCurrent;
var homePageTotalTime;
var homePageElapsedTime;
var homePageMultiplier;
var homePageSubtrahend;
var homePageRefreshTimeMiliseconds = 2500;
var paymentInProgress = false; // flag govori da li je dozvoljen novi transaction request
var balanceRequestInProgress = false; // flag govori da li je dozvoljen novi balance request // mm
var CurrentView = null; // čuva naziv trenutne stranice na kojoj se nalazi aplikacija
var eventAppStart;
var uuid = "DEBUG-1";
var latitude = "";
var longitude = "";
var locatedCityID = 0;
var notificationWait;
var cardIsSupported;
var supportedCards;
var failedAttempt = 0;
var CvvRequired = 1;
var fee = 0;
var paymentStep = 0;
var serviceURL = "https://parkwallet.ipt.hr";
//var serviceURL = "https://parkwallet.ipt.hr:10448";
//var serviceURL = "http://localhost:20744";
//var serviceURL = "http://172.28.8:20744";

var platform = "iOS";
var loggedIn = false;
var userDeviceGuid = "";
var userDeviceID = 0;
var lastUpdateDate = "2007-01-01 10:00:00";
var localDict = "";
var creditCards = [];
var minQ = 1;
var maxQ = 1;
var initialHref = window.location.href;
var lastSelectDate;
var bannerVisible = false;
var bannerHref = "";
var bannerURL = "";

function screenSizeSuccessCb(result) {
    alert(JSON.stringify(result));
}

function screenSizeErrorCb(e) {
    alert('Screen size plugin error: ' + e);
}

function tryAgain() {
    //HideLoading();
    window.location.reload(true);
    //window.location = initialHref;
}

function tokenHandler(result) {
    if (result.length > 0) {
        db.transaction(function (tx) {
            tx.executeSql(
                "SELECT * FROM RegID",
                [],
                function (tx, results) {
                    if (results.rows.length == 0) {
                        AddRegID(result);
                    } else {
                        if (result != results.rows.item(0).Value) {
                            tx.executeSql(
                                "UPDATE RegID SET Value = '" +
                                result +
                                "', ServerNotified = 'false'",
                                [],
                                function () {
                                    UpdateNotificationRegIDOnServer();
                                },
                                null
                            );
                        }
                    }
                },
                null
            );
        });
    }
}

function errorHandler(error) {
    alertBox("Dogodila se greška pri registraciji za primanje notifikacija!");
}

// FirebaseCloudMessage
function onNotificationFCM(e) {
    alertBox(e.body, showAdAfterAlert, translate("obavijest"), translate("ok"));
}

function showAdAfterAlert() {
    //displayAd('Interstitial');
}

// GoogleCloudMessage
function onNotificationGCM(e) {
    switch (e.event) {
        case "registered": // nakon uspješne registracije za primanje push notifikacija
            if (e.regid.length > 0) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "SELECT * FROM RegID",
                        [],
                        function (tx, results) {
                            if (results.rows.length == 0) {
                                AddRegID(e.regid);
                            } else {
                                if (e.regid != results.rows.item(0).Value) {
                                    tx.executeSql(
                                        "UPDATE RegID SET Value = '" +
                                        e.regid +
                                        "', ServerNotified = 'false'",
                                        [],
                                        function () {
                                            UpdateNotificationRegIDOnServer();
                                        },
                                        null
                                    );
                                }
                            }
                        },
                        null
                    );
                });
            }
            break;

        case "message": // nakon primanja push notifikacije od IPT servera
            clearTimeout(notificationWait);

            if (!balanceRequestInProgress) {
                if (CurrentView != "home.html") {
                    RenderView("home.html", "");
                }
            }

            HideLoading();
            alertBox(e.payload.message, null, translate("obavijest"), translate("ok"));
            break;

        case "error": // ako se dogodila greška kod primanja notifikacije
            alertBox(
                translate("greska-kod-zaprimanja-obavijesti") + ": " + e.msg,
                null,
                translate("greska"),
                transalte("ok")
            );
            break;

        default:
            alertBox(
                translate("nepoznat-događaj"),
                null,
                translate("greska"),
                translate("ok")
            );
            break;
    }
}

// iOS PushNotification
function onNotificationAPN(event) {
    if (event.alertBox) {
        clearTimeout(notificationWait);

        if (CurrentView != "home.html") {
            RenderView("home.html", "");
        }

        HideLoading();
        alertBox(event.alertBox, null, translate("obavijest"), translate("ok"));
    }
}

function UpdateToken(token) {
    // save this server-side and use it to push notifications to this device
    if (token.length > 0) {
        //alertBox(translate("novi-token") + token, null, translate("obavijest"), translate("ok"));
        db.transaction(function (tx) {
            tx.executeSql(
                "SELECT * FROM RegID",
                [],
                function (tx, results) {
                    if (results.rows.length == 0) {
                        //alertBox('nismo nasli regID u lokalnoj. Idemo upisati token u server i lokalnu. Token: ' + token);
                        AddRegID(token);
                    } else {
                        //alertBox('nasli smo  regID u lokalnoj. ');
                        if (token != results.rows.item(0).Value) {
                            //alertBox('regID (token) koji smo dobili nije isti ko u lokalnoj. Idemo ga updejtati u lokalnu i na server.');
                            tx.executeSql(
                                "UPDATE RegID SET Value = '" +
                                token +
                                "', ServerNotified = 'false'",
                                [],
                                function () {
                                    UpdateNotificationRegIDOnServer();
                                },
                                null
                            );
                        } else {
                            //alertBox('token koji smo dobili je isti ko u lokalnoj. Nema potrebe za updejtom.');
                        }
                    }
                },
                null
            );
        });
    }
}

function GetPermissionForiOSNotifications() {
    if (deviceOS == "ios") {
        if (window.FirebasePlugin) {
            window.FirebasePlugin.hasPermission(function (data) {
                if (data.isEnabled != true) {
                    window.FirebasePlugin.grantPermission(); // (iOS only);
                }
            });
        }
    }
}

function RegisterDevice() {
    //FCM Plugin ###########################################################################
    //alertBox('RegisterDevice');
    console.log("RegisterDevice");

    if (window.FirebasePlugin) {
        //alertBox('RegisterDevice - window.FirebasePlugin');

        window.FirebasePlugin.onNotificationOpen(onNotificationFCM, function (
            error
        ) {
            //alert(error);
        });

        //window.FirebasePlugin.hasPermission(function (data) {
        //    console.log(data.isEnabled);
        //});

        //window.FirebasePlugin.getToken(function (token) {

        //    UpdateToken(token);
        //    console.log("getToken:");
        //    console.log(token);

        //}, function (error) {
        //    console.error(error);
        //});

        window.FirebasePlugin.onTokenRefresh(
            function (token) {
                // save this server-side and use it to push notifications to this device
                UpdateToken(token);
            },
            function (error) {
                console.error(error);
            }
        );
    }

    //###################################################################################

    //stara verzija plugina

    //var push = PushNotification.init({ "android": {
    //    "senderID": "228174099325"
    //        },
    //             "ios" : {"alert" : "true", "badge" : "true", "sound": "true"}, "windows" : {
    //        }
    //});

    //push.on('registration', function(data) {
    //    alertBox('registration:' + data);
    //});

    //push.on('notification', function (data) {
    //    alertBox('notification');
    //    // data.message,
    //    // data.title,
    //    // data.count,
    //    // data.sound,
    //    // data.image,
    //    // data.additionalData
    //});

    //push.on('error', function (e) {
    //    alertBox('error');
    //    // e.message
    //});

    //pushNotification = window.plugins.pushNotification;

    //if (typeof device != 'undefined' && (device.platform == 'android' || device.platform == 'Android')) {
    //    pushNotification.register(function () { }, function () { }, { "senderID": "470690342666", "ecb": "onNotificationGCM" });
    //} else {
    //    //pushNotification.register(tokenHandler, errorHandler, { "badge": "true", "sound": "true", "alertBox": "true", "ecb": "onNotificationAPN" });
    //}
}

function onBackKeyDown(e) {
    e.stopPropagation();
    Back(true);
};

function onResume() {
    switch (CurrentView) {
        case "history.html":
            LoadTransactions();
            break;

        case "details.html":
            LoadTransaction(selectedTransactionID);
            break;

        case "historynotif.html":
            LoadNotifications();
            break;

        case "detailsnotif.html":
            LoadNotification(selectedNotificationID);
            break;

        case "home.html":
            loadHomeScreen();
            break;
    }
}

// učitava .html stranicu i dodaje ju unutar "content"
// dijela index.html stranice (MasterPage)
function RenderView(view, currentView) {
    if (view != CurrentView) {
        clearInterval(homePageThread);

        $(".charPieSlice3").unbind();
        $(".charPieSlice4").unbind();

        CurrentView = view;

        if (currentView != "") {
            if (callStack != "") {
                callStack = callStack.concat("|", currentView);
            } else {
                callStack = currentView;
            }
        } else {
            callStack = "";
        }

        $.get(view, function (data) {
            $("#scroll-content")
                .html(data)
                .trigger("create");
            ShowHideBackButton();
            InitializeControls(view);

            if (view == 'addvehiclewizard.html' || view == 'addvehicle.html') {
                if (view == 'addvehiclewizard.html') {
                    isVechicleWizard = true;
                }
                else {
                    isVechicleWizard = false;
                }
                document.getElementById('txtNazivVozila').addEventListener('keypress', addVehicleKeyPress);
                document.getElementById('txtRegistracija').addEventListener('keypress', addVehicleKeyPress);
            }

            if (view == 'login.html') {
                document.getElementById('txtKorisnickoIme').addEventListener('keypress', loginKeyPress);
                document.getElementById('txtLozinka').addEventListener('keypress', loginKeyPress);
            }

            initializeDdls();
            updateLanguage();
        });
    }
}

function addVehicleKeyPress(e) {
    if (e.keyCode == 13) {
        AddVehicle(isVechicleWizard);
    }
}

function loginKeyPress(e) {
    if (e.keyCode == 13) {
        LogIn();
    }
}

function initializeDdls() {
    var allDdls = document.getElementsByTagName('select');
    for (var i = 0, len = allDdls.length; i < len; i++) {
        allDdls[i].addEventListener('touchstart', function (e) {
            e.stopPropagation();
        }, false);
    }
}

// zaključuje da li je potrebno sakriti
// ili prikazati tipku back
function ShowHideBackButton() {
    if (platform === "iOS") {
        var pages = callStack.split("|");

        if (pages[0] != "") {
            $("#btnNatrag").show();
        } else {
            $("#btnNatrag").hide();
        }
    } else {
        $("#btnNatrag").hide();
    }
}

// Get geo coordinates
function getMapLocation() {

    navigator.geolocation.getCurrentPosition
        (onMapSuccess, onMapError, { enableHighAccuracy: true });

}


// Success callback for get geo coordinates
var onMapSuccess = function (position) {

    latitude = position.coords.latitude;
    longitude = position.coords.longitude;

    getMap(latitude, longitude);

}

// Get map by using coordinates

function getMap(latitude, longitude) {

    var mapOptions = {
        center: new google.maps.LatLng(0, 0),
        zoom: 1,
        mapTypeId: google.maps.MapTypeId.ROADMAP
    };

    map = new google.maps.Map
        (document.getElementById("map"), mapOptions);


    var latLong = new google.maps.LatLng(latitude, longitude);

    var marker = new google.maps.Marker({
        position: latLong
    });

    marker.setMap(map);
    map.setZoom(15);
    map.setCenter(marker.getPosition());

}

// Error callback

function onMapError(error) {
    console.log('code: ' + error.code + '\n' +
        'message: ' + error.message + '\n');
}

var gnotifRegId = "--";
var notifRegIdSent = "not sent";

// ova metoda služi za inijijalno postavljanje elemenata
// neke stranice, nakon što je ista umetnuta u index.html
function InitializeControls(view) {
    $("footer").hide();
    $(".footerItem").hide();
    $("footer").css("height", "60px");
    $(".btnMenu").hide();
    $("#wrapper")
        .css("margin-bottom", "-120px")
        .css("padding-bottom", "140px");

    //destroyAdBanner();

    switch (view) {

        case "maps.html":
            LoadInitialInformationNew(5);
            $(".btnMenu").show();
            getMapLocation();
            $(".titleText").html(translate('gdje-sam'));
            //$("footer, .logout").show();
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "10px");

            break;

        case "about.html":
            $(".btnMenu").show();
            db.transaction(function (tx) {
                tx.executeSql("SELECT * FROM User", [], function (tx, results) {
                    if (results.rows.length > 0) {
                        var guid = results.rows.item(0).GUID;
                        var shortNotifRegID = (gnotifRegId.length >= 4) ? "ends with '" + gnotifRegId.substr(-4) + "'" : gnotifRegId;
                        if (deviceOS != "browser") {
                            $(".app-info-details").html(
                                "<h3>Info</h3><p>NotifRegID: " +
                                shortNotifRegID + " (" + notifRegIdSent + ")" +
                                "</p><p>User: " +
                                gExistingUser +
                                "</p><p>ParkWallet Version: " +
                                AppVersion.version +
                                "</p><p>GUID: " +
                                guid +
                                "</p><p>OS: " +
                                device.platform +
                                " " +
                                device.version +
                                "</p>"
                            );
                        } else {
                            $(".app-info-details").html(
                                "<h3>Info</h3><p>NotifRegID: " +
                                shortNotifRegID + " (" + notifRegIdSent + ")" +
                                "</p><p>User: " +
                                gExistingUser +
                                "</p><p>ParkWallet Version: -" +
                                "</p><p>GUID: " +
                                guid +
                                "</p><p>OS: browser" +
                                "</p>"
                            );
                        };
                    }
                });
            });

            $(".titleText").html("Info");
            //$("footer, .logout").show();
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "10px");

            break;
        case "login.html":
            $(".titleText").html(translate("prijava"));
            $("footer, .loginScreen").show();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "70px");
            break;

        case "home.html":
            $(".btnMenu").show();
            $(".titleText").html(translate("glavni-izbornik"));
            $(".plati-parkiranje").html(translate("plati-parkiranje"));
            loadHomeScreen();

            setHomeScreenLayout();
            break;

        case "history.html":
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "10px");
            $(".btnMenu").show();
            $(".titleText").html(translate("placanja"));
            $(".nema-placanja").html(translate("nema-placanja"));

            LoadTransactions();
            break;

        case "historynotif.html":
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "10px");
            $(".btnMenu").show();
            $(".titleText").html(translate("notifikacije"));
            $(".nema-placanja").html(translate("nema-notifikacija"));

            LoadNotifications();
            break;

        case "templates.html":
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "10px");
            $(".btnMenu").show();
            $(".titleText").html(translate("predlosci"));
            ShowTemplates();
            break;

        case "newpayment.html":
            $(".btnMenu").show();
            $(".titleText").html(translate("placanje"));
            $("footer").css("height", "120px");
            $("footer, .newpaymentStep1").show();
            $("#quantityWrapper").hide();
            FillVehicleSelectList();
            FillGradoviSelectList();
            FillZoneSelectList();
            FillPeriodList();
            break;

        case "addvehicle.html":

            //var win = window.open("http://sms.ipt.hr/IPTMarket/threed.html", "_blank", "EnableViewPortScale=yes,location=no");

            //win.addEventListener("loadstop", function () {
            //    //win.executeScript({ code: "alert( 'hello' );" });

            //});
            //win.addEventListener('loadstart', function (event) {
            //    var URL = event.url;
            //    var n = URL.includes("ok.html");
            //    if (n == true) {
            //        win.close();
            //        // root reload
            //    }
            //})

            $(".btnMenu").show();
            $(".titleText").html(translate("vozila"));
            $("footer, .newvehicle").show();
            $(".addvehicle").hide();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");

            FillVehicles();
            if (callStack.indexOf("newpayment.html") == -1) {
                $(".newvehicle").show();
            } else {
                ShowAddVehicleForm();
            }

            db.transaction(function (tx) {
                tx.executeSql(
                    "SELECT * FROM Vehicle",
                    [],
                    function (tx, results) {
                        if (results.rows.length == 0) {
                            ShowAddVehicleForm();
                        }
                    },
                    null
                );
            });

            break;

        case "addcardwizard.html":
            if (CvvRequired == 0) {
                $("#cscw").hide();
            } else {
                $("#cscw").show();
            }
            $(".titleText").html(translate("kartica"));
            $("footer, .newcardwizard").show();
            FillCardTypeSelectList();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");
            break;

        case "addcard.html":
            if (CvvRequired == 0) {
                $("#csc").hide();
            } else {
                $("#csc").show();
            }
            $(".btnMenu").show();
            $(".titleText").html(translate("kartica"));
            $("footer, .newcard").show();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");
            FillCardTypeSelectList();
            break;

        case "details.html":
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "20px");
            $(".btnMenu").show();
            $(".titleText").html(translate("transakcija"));
            LoadTransaction(selectedTransactionID);
            break;

        case "detailsnotif.html":
            $("#wrapper")
                .css("margin-bottom", "0px")
                .css("padding-bottom", "20px");
            $(".btnMenu").show();
            $(".titleText").html(translate("notifikacija"));
            LoadNotification(selectedNotificationID);
            break;

        case "cardInformation.html":
            $(".btnMenu").show();
            $(".titleText").html(translate("kartica"));
            $("footer, .deletecard").show();
            $(".description").html(translate("dodaj-karticu"));

            ShowCardInformation();
            break;

        case "addvehiclewizard.html":
            $(".titleText").html(translate("vozilo"));
            $("footer, .nextToAddCard").show();
            LoadVehicleIfExists();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");
            break;

        case "register.html":
            $(".titleText").html(translate("registracija"));
            $("footer, .continueRegistration").show();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");
            break;

        case "resetpassword.html":
            $(".titleText").html(translate("promjena-lozinke"));
            $("footer, .confirmResetPassword").show();
            $("#wrapper")
                .css("margin-bottom", "-60px")
                .css("padding-bottom", "80px");
            break;
    }
}

function setHomeScreenLayout() {
    screenHeight = screen.availHeight - scrWndDiff;
    $("footer").css("height", "120px");
    $("footer, .footerHome").show();
    $(".titleText").html(translate("glavni-izbornik"));

    //alert('Window innerHeight: ' + window.innerHeight);
    //alert('Screen availHeight: ' + screen.availHeight);
    var toMove = (screenHeight - 364) / 2;
    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM Dictionary WHERE KeyName = 'BannerURL'",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    bannerURL = results.rows.item(0).Content;
                    tx.executeSql("SELECT * FROM Dictionary WHERE KeyName = 'BannerHref'",
                        [],
                        function (tx, results) {
                            if (results.rows.length > 0) {
                                bannerHref = results.rows.item(0).Content;
                                tx.executeSql("SELECT * FROM Dictionary WHERE KeyName = 'BannerVisible'",
                                    [],
                                    function (tx, results) {
                                        if (results.rows.length > 0) {
                                            bannerVisible = results.rows.item(0).Content;

                                            if (bannerURL != null && bannerURL != "") {
                                                if (bannerVisible) {
                                                    if (bannerHref != 'null' && bannerHref != '') {
                                                        $("#bannerHref").attr("target", "_blank");
                                                        $("#bannerHref").attr("href", bannerHref);
                                                    } else {
                                                        $("#bannerHref").removeAttr("target");
                                                        $("#bannerHref").removeAttr("href");
                                                    };
                                                    $("#banner").attr("src", bannerURL);
                                                    $("#banner").css("display", "block");
                                                    toMove = (screenHeight - 390) / 2;
                                                } else {
                                                    $("#banner").css("display", "none");
                                                };
                                            } else {
                                                $("#banner").css("display", "none");
                                            }

                                            $(".charPieHolder").css("margin-top", toMove);
                                            $(".homeLargeButton").css("margin-top", toMove);

                                        } else {
                                            $("#banner").css("display", "none");
                                            $(".charPieHolder").css("margin-top", toMove);
                                            $(".homeLargeButton").css("margin-top", toMove);
                                        };
                                    });
                            } else {
                                $("#banner").css("display", "none");
                                $(".charPieHolder").css("margin-top", toMove);
                                $(".homeLargeButton").css("margin-top", toMove);
                            };
                        });
                } else {
                    $("#banner").css("display", "none");
                    $(".charPieHolder").css("margin-top", toMove);
                    $(".homeLargeButton").css("margin-top", toMove);
                }
            },
            null
        );
    });
}

function TemplateCheckPayment(templateID) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Template WHERE TemplateID = " + templateID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    CheckCardCompatibility(results.rows.item(0).CityID, true, templateID);
                }
            },
            null
        );
    });
}

function CheckCardCompatibility(cityID, isTemplate, templateID) {
    if (!isTemplate) {
        var $cardNotSupported = $("#cardNotSupported");
        $cardNotSupported.css("display", "none");
    }

    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM DefaultCard", [], function (tx, results) {
            if (results.rows.length > 0) {
                var defCardID = results.rows.item(0).DefaultCardID;
                tx.executeSql(
                    "SELECT * FROM Card WHERE CardID = " + defCardID,
                    [],
                    function (tx, results) {
                        if (results.rows.length > 0) {
                            var cardTypeID = results.rows.item(0).CardTypeID.toString();

                            tx.executeSql(
                                "SELECT * FROM City WHERE CityID=" + cityID,
                                [],
                                function (tx, results) {
                                    if (results.rows.length > 0) {
                                        var cards = results.rows.item(0).Cards;
                                        cards = cards.split(";");
                                        cardIsSupported = false;
                                        for (i = 0; i < cards.length; i++) {
                                            if (cards[i] === cardTypeID.toString()) {
                                                cardIsSupported = true;
                                                break;
                                            }
                                        }
                                        if (cardIsSupported == false) {
                                            tx.executeSql(
                                                "SELECT * FROM CardType",
                                                [],
                                                function (tx, results) {
                                                    var allCardTypes = new Array();

                                                    for (i = 0; i < results.rows.length; i++) {
                                                        var cardType = new Array();
                                                        cardType[0] = results.rows.item(i).CardTypeID;
                                                        cardType[1] = results.rows.item(i).CardTypeName;

                                                        allCardTypes[i] = cardType;
                                                    }

                                                    supportedCards = "";

                                                    for (i = 0; i < cards.length; i++) {
                                                        for (j = 0; j < allCardTypes.length; j++) {
                                                            if (
                                                                cards[i].toString() ===
                                                                allCardTypes[j][0].toString()
                                                            ) {
                                                                if (supportedCards === "") {
                                                                    supportedCards += allCardTypes[j][1];
                                                                } else {
                                                                    supportedCards += ", ";
                                                                    supportedCards += allCardTypes[j][1];
                                                                }
                                                            }
                                                        }
                                                    }

                                                    if (isTemplate) {
                                                        alertBox(
                                                            translate("kartica-nije-podrzana") +
                                                            translate("podrzane-kreditne-kartice") +
                                                            supportedCards +
                                                            ".",
                                                            null,
                                                            translate("obavijest"),
                                                            translate("ok")
                                                        );
                                                    } else {
                                                        $cardNotSupported.empty();
                                                        $cardNotSupported.append(
                                                            translate("kartica-nije-podrzana")
                                                        );
                                                        $cardNotSupported.append(
                                                            translate("podrzane-kreditne-kartice") +
                                                            supportedCards +
                                                            "."
                                                        );
                                                        $cardNotSupported.css("display", "table");
                                                    }
                                                },
                                                null
                                            );
                                        } else {
                                            if (isTemplate) {
                                                TemplatePayment(templateID, 0);
                                            }
                                        }
                                    }
                                },
                                null
                            );
                        } else {
                            cardIsSupported = true;
                            if (isTemplate) {
                                RenderView("addcard.html", CurrentView);
                            }
                        }
                    },
                    null
                );
            } else {
                cardIsSupported = true;
                if (isTemplate) {
                    RenderView("addcard.html", CurrentView);
                }
            }
        });
    });
}

function SetLanguageFromServer(data) {
    langId = data;
}

function GetLanguageFromServer() {
    var guid = userDeviceGuid;

    $.ajax({
        url: serviceURL + "/api/MobileApi/GetLanguage",
        type: "GET",
        data: { guid: guid },
        success: function (languageFromServer) {
            if (languageFromServer != "") {
                var data = languageFromServer;
                SetLanguageFromServer(data);
                db.transaction(function (tx) {
                    tx.executeSql(
                        "UPDATE ChosenLanguage SET LanguageID = '" + data + "'",
                        [],
                        function (tx) {
                            tx.executeSql(
                                "SELECT * FROM Language WHERE LanguageID = " + data,
                                [],
                                function (tx, results1) {
                                    lang = results1.rows.item(0).Ticker;
                                    langId = results1.rows.item(0).LanguageID;
                                    state = results1.rows.item(0).State;
                                    languageGotFromServer = 1;
                                    updateLanguage();
                                    $(".titleText").html(translate("glavni-izbornik"));
                                }
                            );
                        },
                        null
                    );
                });
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}

function loadHomeScreen() {
    //SetBackListener();
    clearInterval(homePageThread);
    paymentStep = 0;
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    userDeviceGuid = guid;
                    loggedIn = results.rows.item(0).IsLogin;
                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/GetCurrentParkingReservation",
                        type: "POST",
                        data: { guid: guid },
                        success: function (results) {
                            if (results.Status == 1 && results.Current > results.Start) {
                                // prikaži SAT
                                $(".charPieHolder").css("display", "block");
                                $(".homeLargeButton").css("display", "none");

                                $("#registracija").empty();
                                $("#registracija").append(results.Ticket);

                                db.transaction(function (tx) {
                                    tx.executeSql(
                                        "SELECT * FROM Zone WHERE ZoneID = '" +
                                        results.ZoneID +
                                        "'",
                                        [],
                                        function (tx, result) {
                                            if (result.rows.length > 0) {
                                                $("#zona").empty();
                                                $("#zona").append(result.rows.item(0).Name);
                                                var color = result.rows.item(0).Color;
                                                if (color != null) {
                                                    $("#zona").css("background-color", color);
                                                }

                                                homePageDegree = 360;
                                                // datumi i vrijeme dobiveno od servera
                                                homePageDateStart = new Date(results.Start * 1000);
                                                homePageDateEnd = new Date(results.End * 1000);
                                                homePageDateCurrent = new Date(results.Current * 1000);
                                                // ukupno trajanje rezervacije parkinga
                                                homePageTotalTime = Math.abs(
                                                    homePageDateEnd.getTime() -
                                                    homePageDateStart.getTime()
                                                );
                                                // proteklo vrijeme od početka rezervacije parkiranja
                                                homePageElapsedTime = Math.abs(
                                                    homePageDateCurrent.getTime() -
                                                    homePageDateStart.getTime()
                                                );
                                                homePageMultiplier = 360 / homePageTotalTime;
                                                homePageSubtrahend =
                                                    homePageMultiplier * homePageElapsedTime;
                                                homePageDegree = 360 - homePageSubtrahend;
                                                ShowRemainingTimeOnHomeScreen();
                                                decreasesDegree(true);
                                            }
                                        },
                                        null
                                    );
                                });
                                //AppRate.promptForRating();
                            } else {
                                // prikaži GUMB
                                $(".charPieHolder").css("display", "none");
                                $(".homeLargeButton").css("display", "block");
                                if (deviceOS != "browser") {
                                    AppRate.promptForRating(false);
                                }
                            }
                            HideLoading();
                            if (languageGotFromServer == 0) GetLanguageFromServer();
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });
}

function decreasesDegree(initial) {
    homePageElapsedTime = homePageElapsedTime + homePageRefreshTimeMiliseconds;
    homePageSubtrahend = homePageMultiplier * homePageElapsedTime;

    var $slice3 = $(".charPieSlice3");
    var $slice4 = $(".charPieSlice4");

    if (homePageSubtrahend > 360) {
        clearInterval(homePageThread);
        $(".charPieHolder").css("display", "none");
        $(".homeLargeButton").css("display", "block");
    } else {
        if (initial) {
            if (homePageSubtrahend <= 0) {
                // isteklo vrijeme
                homePageThread = setInterval(function () {
                    decreasesDegree(false);
                }, homePageRefreshTimeMiliseconds);
            } else if (homePageSubtrahend <= 180) {
                // manje od pola vremena
                var degree = 180 + homePageSubtrahend;
                $slice3.css("-webkit-transform", "rotate(180deg)");
                $slice4.css("-webkit-transform", "rotate(" + degree + "deg)");

                homePageThread = setInterval(function () {
                    decreasesDegree(false);
                }, homePageRefreshTimeMiliseconds);
            } else {
                // više od pola vremena
                var devider = 1 / 180;
                var duration = 1 - homePageDegree * devider;

                $slice4.css("-webkit-transform", "rotate(360deg)").hide();
                $slice3.css(
                    "-webkit-transform",
                    "rotate(" + homePageSubtrahend + "deg)"
                );

                if (homePageSubtrahend > 270) {
                    $slice3.css("background-color", "red");
                }

                homePageThread = setInterval(function () {
                    decreasesDegree(false);
                }, homePageRefreshTimeMiliseconds);
            }

            HideLoading();
        } else {
            // više od pola vremena
            if (homePageSubtrahend > 180) {
                $slice4.css("-webkit-transform", "rotate(360deg)").hide();
                $slice3.css(
                    "-webkit-transform",
                    "rotate(" + homePageSubtrahend + "deg)"
                );

                if (homePageSubtrahend > 270) {
                    $slice3.css("background-color", "red");
                }
            } else {
                // manje od pola vremena
                var degree = 180 + homePageSubtrahend;
                $slice3.css("-webkit-transform", "rotate(180deg)");
                $slice4.css("-webkit-transform", "rotate(" + degree + "deg)");
            }
        }
    }

    ShowRemainingTimeOnHomeScreen();
}

function ShowRemainingTimeOnHomeScreen() {
    var minutes = parseInt((homePageTotalTime - homePageElapsedTime) / 60000);
    var elapsedTimeText;

    if (minutes > 0) {
        var hour = parseInt(minutes / 60);
        if (hour <= 23) {
            var minutes = parseInt(minutes % 60);

            if (minutes % 60 == 0) {
                elapsedTimeText = hour + ":00";
            } else {
                if (minutes < 10) {
                    elapsedTimeText = hour + ":0" + minutes;
                } else {
                    elapsedTimeText = hour + ":" + minutes;
                }
            }
        } else {
            var day = parseInt(hour / 24);

            var hourRest = hour - day * 24;
            if (hourRest % 24 == 0) {
                hourRest = "00";
            } else {
                if (hourRest < 10) {
                    hourRest = "0" + hourRest;
                }
            }

            var minutes = parseInt(minutes % 60);
            if (minutes % 60 == 0) {
                minutes = "00";
            } else {
                if (minutes < 10) {
                    minutes = "0" + minutes;
                }
            }

            elapsedTimeText = day + "d " + hourRest + ":" + minutes;
        }
    } else {
        elapsedTimeText = "- : -";
    }

    $("#sat").empty();
    $("#sat").append(elapsedTimeText);
}

function PredlosciOnClick() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Template INNER JOIN Vehicle ON Template.VehicleID = Vehicle.VehicleID " +
            "INNER JOIN City ON Template.CityID = City.CityID INNER JOIN Zone ON Template.ZoneID = Zone.ZoneID " +
            "INNER JOIN ZoneTariff ON Template.ZoneTariffID = ZoneTariff.ZoneTariffID",
            [],
            function (tx, results) {
                if (results.rows.length == 0) {
                    alertBox(
                        translate("nema-pohranjenih-predlozaka"),
                        null,
                        translate("obavijest"),
                        translate("ok")
                    );
                } else {
                    RenderView("templates.html", "home.html");
                }
            },
            null
        );
    });
}

function SaveSelectOld() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM LastSelect",
            [],
            function (tx, results) {
                if (results.rows.length == 0) {
                    tx.executeSql(
                        "INSERT INTO LastSelect (CityID, ZoneID, ZoneTariffID, Quantity) VALUES (" +
                        parseInt($("#ddlGradovi").val()) +
                        ", " +
                        parseInt($("#ddlZone").val()) +
                        ", " +
                        parseInt($("#ddlTarife").val()) +
                        ", " +
                        parseInt($("#quantity").html()) +
                        ")"
                    );
                } else {
                    tx.executeSql(
                        "UPDATE LastSelect SET CityID = " +
                        parseInt($("#ddlGradovi").val()) +
                        ", ZoneID = " +
                        parseInt($("#ddlZone").val()) +
                        ", ZoneTariffID = " +
                        parseInt($("#ddlTarife").val()) +
                        ", Quantity = " +
                        parseInt($("#quantity").html())
                    );
                }
            },
            null
        );
    });
}

function SaveSelect() {

    var currentdate = new Date();
    var lastSelectDate = currentdate.getFullYear() + '-' + (currentdate.getMonth() + 1) + "-" + currentdate.getDate() + " " + currentdate.getHours() + ":" + currentdate.getMinutes() + ":" + currentdate.getSeconds();

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM LastSelect",
            [],
            function (tx, results) {
                if (results.rows.length == 0) {
                    tx.executeSql(
                        "INSERT INTO LastSelect (CityID, ZoneID, ZoneTariffID, Quantity, LastSelectDate) VALUES (" +
                        parseInt($("#ddlGradovi").val()) +
                        ", " +
                        parseInt($("#ddlZone").val()) +
                        ", " +
                        parseInt($("#ddlTarife").val()) +
                        ", " +
                        parseInt($("#quantity").html()) +
                        ", '" +
                        lastSelectDate +
                        "')"
                    );
                } else {
                    tx.executeSql(
                        "UPDATE LastSelect SET CityID = " +
                        parseInt($("#ddlGradovi").val()) +
                        ", ZoneID = " +
                        parseInt($("#ddlZone").val()) +
                        ", ZoneTariffID = " +
                        parseInt($("#ddlTarife").val()) +
                        ", Quantity = " +
                        parseInt($("#quantity").html()) +
                        ", LastSelectDate = '" +
                        lastSelectDate + "'"
                    );
                }
            },
            null
        );
    });
}

function OnClickDdlGradovi() {
    FillZoneSelectList();
    FillPeriodList();
    var cityID = parseInt($("#ddlGradovi").val());
    if (cityID == 0) {
        $("#detailedClientDesc").css("display", "none");
    }
    //SaveSelect();
}

function OnClickDdlZone() {
    FillPeriodList();
    SetZoneColor();
    //SaveSelect();
}

function OnClickDdlTarife() {
    SetMinMaxValue(1);
    //SaveSelect();
}

function AddQ() {
    var currentQ = parseInt($("#quantity").html());
    var qtoBe = currentQ + 1;
    if (maxQ >= qtoBe) {
        $("#quantity").html("");
        $("#quantity").append(qtoBe);
        SaveSelect();
    }
}

function RemoveQ() {
    var currentQ = parseInt($("#quantity").html());
    var qtoBe = currentQ - 1;
    if (qtoBe >= 1) {
        $("#quantity").html("");
        $("#quantity").append(qtoBe);
        SaveSelect();
    }
}

function SetMinMaxValue(quantity) {
    $("#quantityWrapper").hide();
    var tariffID = parseInt($("#ddlTarife").val());
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM ZoneTariff WHERE ZoneTariffID = " + tariffID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    maxQ = results.rows.item(0).MaxQuantity;
                    if (results.rows.item(0).MaxQuantity >= quantity) {
                        $("#quantity").html("");
                        $("#quantity").append(quantity);
                    } else {
                        $("#quantity").html("");
                        $("#quantity").append("1");
                    }
                    if (results.rows.item(0).MaxQuantity > 1) {
                        $("#quantityWrapper").show();
                    }
                } else {
                    $("#quantity").attr({ max: 1, min: 1 });
                    $("#quantity").html("");
                    $("#quantity").append("1");
                }
                //ovdje postavljamo i eventualni detaljni opis tarife, ako ga ima
                detailed = results.rows.item(0).DetailedClientDesc;
                var $detailedClientDesc = $("#detailedClientDesc");
                if (detailed != "") {
                    $detailedClientDesc.empty();
                    $detailedClientDesc.append(detailed);
                    $detailedClientDesc.css("display", "table");
                } else {
                    $detailedClientDesc.css("display", "none");
                };
                SaveSelect();
                //displayAd('Banner');
            }
        );
    });
}

function ValidateMonth(month) {
    if (month.length > 2) {
        return false;
    }

    var months = "(1[0-2]|0[1-9]|d)";
    if (month.match(months)) {
        return true;
    } else {
        return false;
    }
}

function ValidateYear(year) {
    if (year.length > 2) {
        return false;
    }

    var minYear = parseInt(
        new Date()
            .getFullYear()
            .toString()
            .substring(2, 4)
    );
    var maxYear = minYear + 20;

    year = parseInt(year);

    if (isNaN(year)) {
        return false;
    } else {
        if (year >= minYear && year <= maxYear) {
            return true;
        } else {
            return false;
        }
    }
}

function ValidateMonthAndYear(month, year) {
    var today = new Date();
    var currentYear = parseInt(
        today
            .getFullYear()
            .toString()
            .substring(2)
    );
    var currentMonth = today.getMonth();
    currentMonth++;

    if (currentYear > year) {
        return false;
    } else if (currentYear < year) {
        return true;
    } else {
        if (currentMonth > month) {
            return false;
        } else {
            return true;
        }
    }
}

function SanitizePlateNumber(plateNumber) {
    // the characters i'm looking for in a string:
    var charList = [
        '"',
        "<",
        ">",
        "?",
        "!",
        ")",
        "(",
        "/",
        "$",
        "&",
        "%",
        "#",
        "*",
        "+",
        "=",
        "_",
        ";",
        ",",
        ".",
        ":",
        "-",
        " ",
        "Ą",
        "ą",
        "Ć",
        "ć",
        "Č",
        "ć",
        "Ę",
        "ę",
        "È",
        "è",
        "Ł",
        "ł",
        "Ó",
        "ó",
        "Ś",
        "ś",
        "Š",
        "š",
        "Ź",
        "ź",
        "Ż",
        "ź",
        "Ž",
        "ž",
        "Đ",
        "đ",
        "Ó",
        "ó",
        "Ö",
        "ö",
        "Ü",
        "ü",
        "Ä",
        "ä",
        "Ë",
        "ë",
        "Ï",
        "ï",
        "À",
        "à",
        "Á",
        "á",
        "Â",
        "â",
        "Ã",
        "ã",
        "Å",
        "å",
        "Æ",
        "æ",
        "Ç",
        "ç",
        "É",
        "é",
        "Ê",
        "ê",
        "Ì",
        "ì",
        "Í",
        "í",
        "Î",
        "î",
        "Ñ",
        "ñ",
        "Ò",
        "ò",
        "Ó",
        "ó",
        "Ô",
        "ô",
        "Õ",
        "õ",
        "Ø",
        "ø",
        "Ù",
        "ù",
        "Ú",
        "ú",
        "Û",
        "û",
        "Ü",
        "ü"
    ];

    // the characters i'd like to replace them with:
    var replaceList = [
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        " ",
        "A",
        "a",
        "C",
        "c",
        "C",
        "c",
        "E",
        "e",
        "E",
        "e",
        "L",
        "l",
        "O",
        "o",
        "S",
        "s",
        "S",
        "s",
        "Z",
        "z",
        "Z",
        "z",
        "Z",
        "z",
        "D",
        "d",
        "O",
        "o",
        "O",
        "o",
        "U",
        "u",
        "A",
        "a",
        "E",
        "e",
        "I",
        "i",
        "A",
        "a",
        "A",
        "a",
        "A",
        "a",
        "A",
        "a",
        "A",
        "a",
        "E",
        "e",
        "C",
        "c",
        "E",
        "e",
        "E",
        "e",
        "I",
        "i",
        "I",
        "i",
        "I",
        "i",
        "N",
        "n",
        "O",
        "o",
        "O",
        "o",
        "O",
        "o",
        "O",
        "o",
        "O",
        "o",
        "U",
        "u",
        "U",
        "u",
        "U",
        "u",
        "U",
        "u"
    ];

    var sanitizedPlateNumber = plateNumber;
    var limit = sanitizedPlateNumber.length;
    for (i = 0; i < limit; i++) {
        for (var j in charList) {
            if (sanitizedPlateNumber.charAt(i) === charList[j]) {
                //našao sam karakter u registarskoj oznaci na poziciji i, koji odgovara problematičnom karakteru na poziciji j
                sanitizedPlateNumber = sanitizedPlateNumber.replace(
                    sanitizedPlateNumber.charAt(i),
                    replaceList[j]
                );
                //kako je moguće da smo ovim postupkom maknuli
            }
        }
    }
    sanitizedPlateNumber = sanitizedPlateNumber.replace(/\s/g, "");
    return sanitizedPlateNumber;
}

function ValidatePlateNumber(plateNumber) {
    if (plateNumber.length < 2 || plateNumber > 10) {
        return false;
    }

    var regularExpression = /^[a-zA-Z0-9]+$/;
    var valid = regularExpression.test(plateNumber);
    return valid;
}

function ValidateCvv(cvv, cardTypeId) {
    if (cardTypeId === "5") {
        // MAESTRO
        return true;
    } else {
        var regularExpression = /^[0-9]{3,4}$/;
        var valid = regularExpression.test(cvv);
        return valid;
    }
}

// kada je riječ o account-u, a ne kreditnoj ili debitnoj kartici
function ValidateAvc(avc) {
    var regularExpression = /^[0-9]{4,4}$/;
    var valid = regularExpression.test(avc);
    return valid;
}

function LoadVehicleIfExists() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Vehicle",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var vehicle = results.rows.item(0).Name;
                    var plateNumber = results.rows.item(0).PlateNumber;

                    $("#txtNazivVozila").val(vehicle);
                    $("#txtRegistracija").val(plateNumber);
                }
            },
            null
        );
    });
}

function OnLanguageChange() {
    updateLanguage();
}

function OnVehicleChange() {
    var vehicleID = parseInt($("#ddlVozila").val());

    db.transaction(function (tx) {
        tx.executeSql("UPDATE Vehicle SET CurrentSelected = 'false'");
        tx.executeSql(
            "UPDATE Vehicle SET CurrentSelected = 'true' WHERE VehicleID = " +
            vehicleID
        );

        tx.executeSql(
            "SELECT * FROM Vehicle WHERE VehicleID = " + vehicleID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    $("#vehicleName").empty();
                    $("#vehicleName").append(results.rows.item(0).Name);
                }
            },
            null
        );
    });
}

function ShowCardInformation() {
    var maskedCardNumber;
    var cardTypeID;
    var cardTypeName;
    var cardImg;
    var cardExp;
    var cardId;
    var defaultCardID;
    var disabled;
    var checked;
    let isAccount = false;

    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM DefaultCard", [], function (tx, results) {
            if (results.rows.length > 0) {
                defaultCardID = results.rows.item(0).DefaultCardID;

                tx.executeSql(
                    "SELECT * FROM Card inner join CardType on Card.CardTypeID = CardType.CardTypeID",
                    [],
                    function (tx, results) {
                        if (results.rows.length > 0) {
                            var htmlCards = "";

                            for (i = 0; i < results.rows.length; i++) {
                                cardId = results.rows.item(i).CardID;
                                maskedCardNumber = results.rows.item(i).CardPreview;
                                cardTypeID = results.rows.item(i).CardTypeID;
                                cardTypeName = results.rows.item(i).CardTypeName;
                                cardExp = results.rows.item(i).ExpDate;
                                isAccount = results.rows.item(i).IsAccount;

                                cardImg = "CreditCard";

                                switch (cardTypeID) {
                                    case 1:
                                        cardImg = "AMEX";
                                        break;
                                    case 2:
                                        cardImg = "VISA";
                                        break;
                                    case 3:
                                        cardImg = "MasterCard";
                                        break;
                                    case 4:
                                        cardImg = "Diners";
                                        break;
                                    case 5:
                                        cardImg = "Maestro";
                                        break;
                                    case 6:
                                        cardImg = "ZINXSmartCity";
                                        break;
                                }

                                disabled = "";
                                checked = "";

                                if (defaultCardID === cardId) {
                                    disabled = "disabled";
                                    checked = "checked";
                                }

                                if (!isAccount) {
                                    htmlCards =
                                        htmlCards +
                                        '<div class="cardsRow"><div class="cardsLogoCell"><img src="Images/' +
                                        cardImg +
                                        '.gif" /></div><div class="cardsInfoCell"><div>' +
                                        cardTypeName +
                                        " (" +
                                        maskedCardNumber +
                                        ")" +
                                        "</div><div>" +
                                        translate("valjanost") +
                                        " " +
                                        cardExp +
                                        '</div></div><div class="cardCheckBoxCell"><input onchange="CardChecked(this, ' +
                                        cardId +
                                        ')" type="checkbox" ' +
                                        disabled +
                                        " " +
                                        checked +
                                        ' /></div><div class="cardDeleteCell"><img onclick="DeleteCard(' +
                                        cardId +
                                        ')" src="Images/Delete.png" /></div></div>';
                                } else {
                                    htmlCards = htmlCards +
                                        `<div class="cardsRow">
                                            <div class="cardsLogoCell">
                                                <img src="Images/${cardImg}.png" />
                                                <!-- <div class="smart-city-card">Smart City &#9819;</div> -->
                                            </div>
                                            <div class="cardsInfoCell">
                                                <div class="cardsNameMaskedNumber">
                                                    ${cardTypeName} (${maskedCardNumber})
                                                </div>
                                                <div class="getSaldoContainer">
                                                    <input type="password" id="getSaldoPIN" placeholder="PIN" onkeypress="return isNumberKey(event)" onkeyup='ValidateGetSaldoPinLength(event)'>
                                                    <i id="eye-icon-id" toggle="#getSaldoPIN" onclick="onEyeIconClick()" class="input-eye-icon">&#128065;</i>
                                                    <a href='#' id="getSaldoHref" class='get-saldo-href-disabled' onclick='GetSaldo(${cardId}); return false;'> ${translate("vidi-stanje-na-racunu")}</a>
                                                </div>
                                            </div>
                                            <div class="cardCheckBoxCell">
                                                <input onchange="CardChecked(this, ${cardId})" type="checkbox" ${disabled} ${checked} />
                                            </div>
                                            <div class="cardDeleteCell">
                                                <img onclick="DeleteCard(${cardId})" src="Images/Delete.png" />
                                            </div>
                                        </div>`
                                }
                            }

                            $("#cards").html("");
                            $("#cards").append(htmlCards);
                        }
                    },
                    null
                );
            }
        });
    });
}

// mm
let isGetSaldoPINInputValid = false;
function isNumberKey(evt) {

    isGetSaldoPINInputValid = false;
    var charCode = (evt.which) ? evt.which : event.keyCode;
    if (charCode > 31 && (charCode < 48 || charCode > 57))
        return false;

    // ne dopustiti unos više od 4 znaka
    //if (evt.target.value.length >= 4) return false;

    isGetSaldoPINInputValid = true;
    return true;
}

// mm
function ValidateGetSaldoPinLength(evt) {
    // ovisno o broju unesenih znamenki, promijeni klasu i uključi/isključi button
    if (evt.target.value.length >= 4) {
        isGetSaldoPINInputValid = true;
        document.getElementById("getSaldoHref").classList.remove('get-saldo-href-disabled');
        document.getElementById("getSaldoHref").classList.add('get-saldo-href');
    } else {
        isGetSaldoPINInputValid = false;
        document.getElementById("getSaldoHref").classList.remove('get-saldo-href');
        document.getElementById("getSaldoHref").classList.add('get-saldo-href-disabled');
    };
}

function onEyeIconClick() {
    var input = $($("#eye-icon-id").attr("toggle"));
    if (input.attr("type") == "password") {
        input.attr("type", "text");
    } else {
        input.attr("type", "password");
    }
};

function CardChecked(checkbox, cardId) {
    $("input:checkbox")
        .attr("checked", false)
        .attr("disabled", false);

    checkbox.checked = true;
    checkbox.disabled = true;

    db.transaction(function (tx) {
        tx.executeSql("DELETE FROM DefaultCard", [], function (tx, results) {
            tx.executeSql("INSERT INTO DefaultCard VALUES (" + cardId + ")");
        });
    });
}

// na klik on Kartice u izborniku
function KarticeOnClick() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Card",
            [],
            function (tx, results) {
                if (results.rows.length == 0) {
                    RenderView("addcard.html", "home.html");
                } else {
                    RenderView("cardInformation.html", "home.html");
                }
            },
            null
        );
    });
}

function DeleteCardsFromDatabase() {
    db.transaction(function (tx) {
        tx.executeSql(
            "DELETE FROM Card",
            [],
            function () {
                Back(false);
            },
            null
        );
    });
}

function DeleteCardCallback(cardID) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    tx.executeSql(
                        //"SELECT * FROM Card WHERE CardID = " + cardID,
                        "SELECT * FROM Card inner join CardType on Card.CardTypeID = CardType.CardTypeID WHERE CardID = " + cardID, // mm
                        [],
                        function (tx, results) {
                            if (results.rows.length > 0) {
                                var cardTypeID = results.rows.item(0).CardTypeID;
                                let isAccount = results.rows.item(0).IsAccount;
                                let _url = "";
                                if (!isAccount) {
                                    _url = serviceURL + "/api/MobileApi/UpdateCard";
                                } else {
                                    _url = serviceURL + "/api/AccountApi/UpdateAccount";
                                }
                                
                                ShowLoading();
                                $.ajax({
                                    url: _url,
                                    type: "POST",
                                    data: { GUID: guid, Action: 2, CardTypeID: cardTypeID },
                                    success: function (results) {
                                        if (results.Status == 1) {
                                            db.transaction(function (trx) {
                                                trx.executeSql(
                                                    "DELETE FROM Card WHERE CardID = " + cardID,
                                                    [],
                                                    function (tx, results) {
                                                        ////ovdje treba još možda postaviti defaultnu karticu
                                                        tx.executeSql(
                                                            "SELECT * FROM DefaultCard WHERE DefaultCardID = " +
                                                            cardID,
                                                            [],
                                                            function (tx, results) {
                                                                if (results.rows.length > 0) {
                                                                    //ovo je baš bila defaultna kartica, ako postoji još neka kartica postavi je kao defaultnu
                                                                    tx.executeSql(
                                                                        "SELECT * FROM Card",
                                                                        [],
                                                                        function (tx, results) {
                                                                            if (results.rows.length > 0) {
                                                                                //imamo još jednu ili više kartica
                                                                                var newDefaultCardID = results.rows.item(
                                                                                    0
                                                                                ).CardID;
                                                                                tx.executeSql(
                                                                                    "UPDATE DefaultCard SET DefaultCardID = " +
                                                                                    newDefaultCardID,
                                                                                    [],
                                                                                    function (tx, results) {
                                                                                        //console.log("New default card set automatically.");
                                                                                    }
                                                                                );
                                                                            }
                                                                        }
                                                                    );
                                                                }
                                                            }
                                                        );
                                                        Back(false);
                                                    },
                                                    null
                                                );
                                            });
                                            HideLoading();
                                        }
                                    },
                                    error: ajaxError,
                                    timeout: timeout
                                });
                            }
                        },
                        null
                    );
                }
            },
            null
        );
    });
}

function DeleteCard(cardID) {
    confirmBox(
        translate("brisati-karticu"),
        translate("brisanje-kartice"),
        translate("siguran-sam"),
        translate("odustani"),
        cardID,
        DeleteCardCallback
    );
}

// metoda koja hendla tipku back
function Back(IsHardwareButton) {

    if (CurrentView === "register.html") {
        if (!$(".registerStep1").is(":visible")) {
            $(".registerStep1").show();
            $(".continueRegistration").show();
            $(".registerStep2").hide();
            $(".confirmRegistration").hide();
            return;
        }
    };

    clearInterval(homePageThread);

    var pages = callStack.split("|");

    //alert('callStack: ' + callStack);
    //alert('if: ' + pages[0] != "");
    //alert('pages: ' + pages);

    if (pages[0] != "") {
        $.get(pages[pages.length - 1], function (data) {
            $("#scroll-content")
                .html(data)
                .trigger("create");
            callStack = callStack.substring(0, callStack.lastIndexOf("|"));
            ShowHideBackButton();
            InitializeControls(pages[pages.length - 1]);
            initializeDdls();
            CurrentView = pages[pages.length - 1];
            updateLanguage();
        });
    } else {
        if (IsHardwareButton) {
            navigator.app.exitApp();
        }
    }
}

function maxLengthCheck(object) {
    if (isNaN(object.value.slice(0, 1))) {
        object.value = object.value.slice(1, 2);
    }

    if (isNaN(object.value.slice(1, 2))) {
        object.value = object.value.slice(0, 1);
    }
    //if (object.value.length > object.maxLength)
    //  object.value = object.value.slice(0, object.maxLength);
}

function SetDictionary(data) {
    dictionary = data;
    //    $(".titleText").html(translate("glavni-izbornik"));
}

function RefreshLanguages(tx) {
    var self = this;
    self.tx = tx;

    $.ajax({
        url: serviceURL + "/api/MobileApi/GetLanguageTable",
        type: "GET",
        success: function (res) {
            if (res) {
                db.transaction(function (tx) {
                    tx.executeSql("DROP TABLE Language", [], function (tx, results) {
                        tx.executeSql("CREATE TABLE IF NOT EXISTS Language (LanguageID, Name, Ticker, State)", [], function (tx) {
                            for (i = 0; i < res.length; i++) {
                                var o = new Option(res[i].name, res[i].languageId);
                                $(o).html(res[i].name);
                                $("#language").append(o);
                                tx.executeSql(
                                    "INSERT INTO Language (LanguageID, Name, Ticker, State) VALUES (" +
                                    res[i].languageId +
                                    ', "' +
                                    res[i].name +
                                    '", "' +
                                    res[i].shortName.toLowerCase() +
                                    '", "' +
                                    res[i].state.toUpperCase() +
                                    '")'
                                );
                            }
                            $("#language").val(langId);
                        }
                        );
                    });
                });
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}

var scrWndDiff = 90;

function PreInitializeApp() {
    scrWndDiff = screen.availHeight - window.innerHeight;
    screenHeight = screen.availHeight - scrWndDiff;
    DetectPlatform();
	ShowLoading();
    GetDictionary();
}

var Version = 360;

function fillDatabase() {
   
}

// inicijalizacija baze podataka i aplikacije
function InitializeApp() {
    //alertBox('InitializeApp');
    console.log("InitializeApp");

    //$.getJSON("dictionary.json", function(data) {
    //  dictionary = data;
    //});
    //  alertBox("Počinjemo!", null, "Start", translate("ok"));

    //GetDictionary();

    // kreira bazu podataka ako ne postoji
    if(deviceOS == 'android' || deviceOS == 'browser'){
		if(deviceOS == 'android'){
			db = openDatabase("mpbz", "1.0", "mPBZ database", 5 * 1024 * 1024);								
		}
		else{
			db = openDatabase("mpbz", "1.0", "mPBZ database", 5 * 1024 * 1024);					
		}
	}
	else{
		if(deviceOS == 'ios'){
			if(sqlitePlugin){
				db = sqlitePlugin.openDatabase("mpbz", "1.0", "mPBZ database", 5 * 1024 * 1024);									
			}
			else{
				alert('Major fuck-up: SQL lite plugin does not exist on iOS, so database support is disabled - unable to create local database. Quitting.');
				return;
			}
		}
	}

    // ako je kreirana baza napunimo ju tablicama
    if (db != null) {

                                        //db.transaction(function (tx) {
                                        //    tx.executeSql("SELECT * FROM Language",
                                        //        [],
                                        //        function (tx, results) {
                                        //            console.log("Baza postoji");
                                        //            //alertBox(
                                        //            //    "Baza postoji",
                                        //            //    null,
                                        //            //    "Info",
                                        //            //    translate("ok")
                                        //            //);
                                        //            //da li postoji tablica version?
                                        //            tx.executeSql("SELECT * FROM Version",
                                        //                [],
                                        //                function(tx, results){
                                        //                    console.log("Tablica Version postoji");
                                        //                    if (results.rows.length == 0) {
                                        //                        //nema redova u tablici version - kao da tablica ni ne postoji, dakle, stara baza!
                                        //                        clearDBOnly().then(() => {
                                        //                            db.transaction(populateDB, errorCB, successCB);
                                        //                        })
                                        //                        .catch(function (rej) {
                                        //                            console.log(rej);
                                        //                        });
                                        //                    } else {
                                        //                        //ima jedan ili više redova, sada provjeriti vrijednost u polju Version
                                        //                        var ver = results.rows.item(0).Version;
                                        //                        if (ver - Version < 0) {
                                        //                            //stara baza!
                                        //                            clearDBOnly().then(() => {
                                        //                                db.transaction(populateDB, errorCB, successCB);
                                        //                            })
                                        //                            .catch(function (rej) {
                                        //                                console.log(rej);
                                        //                            });
                                        //                        }
                                        //                        else {
                                        //                            //baza je up-to-date
                                        //                            // do nothing special
                                        //                            console.log("Postoji baza i ima ispravnu verziju. Ne činimo ništa posebno, nego nastavljamo sa statanjem po proceduri i sadržaju baze. Očekivano je da se korisniku ne daje na izbor jezik, jer je to već konfigurirano.");
                                        //                            db.transaction(populateDB, errorCB, successCB);
                                        //                        }
                                        //                    }
                                        //                },
                                        //                function (tx, error) {
                                        //                    //tablica version ne postoji - dakle, stara baza!
                                        //                    console.log("Tablica Version ne postoji");
                                        //                    //obrisati sve živo
                                        //                    clearDBOnly().then(() => {
                                        //                        db.transaction(populateDB, errorCB, successCB);
                                        //                    })
                                        //                    .catch(function (rej) {
                                        //                        console.log(rej);
                                        //                    });
                                        //                });
                                        //        },
                                        //        function (tx, error) {
                                        //            //console.log("Baza ne postoji");
                                        //            //alertBox(
                                        //            //    "Baza ne postoji",
                                        //            //    null,
                                        //            //    "Info",
                                        //            //    translate("ok")
                                        //            //);
                                        //            console.log("Baza uopće ne postoji. Ovo je vjerojatno prvo startanje nakon instalacije. Ne činimo ništa posebno, nego nastavljamo sa stratanjem po proceduri. Očekuje se izbornik jezika.");
                                        //            db.transaction(populateDB, errorCB, successCB);
                                        //        });
                                        //});
        db.transaction(populateDB, errorCB, successCB);
    } else {
        alertBox(
            translate("nedostupna-lokalna-baza-pdataka"),
            null,
            translate("greska"),
            translate("ok")
        );
    }

    // kreira sve potrebne tablice za rad aplikacije
    function populateDB(tx) {
        //alert('kreiranje baze');
        console.log("populateDB");

        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Version (Version INTEGER NOT NULL)", [],
            function (tx) {
                tx.executeSql("SELECT * FROM Version", [], function (tx, results) {
                    if (results.rows.length == 0) {
                        tx.executeSql("INSERT INTO Version (Version) VALUES ('" + Version + "')",
                            [],
                            function (tx) {
                            },
                            function (tx, error) {
                            });
                    }
                    else {
                        tx.executeSql("UPDATE Version SET Version = '" + Version + "'",
                            [],
                            function (tx) {
                            },
                            function (tx, error) {
                            });
                    };
                })
            });

        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS User (UserID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, Username, Password, GUID, IsWizardComplete, IsLogin)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Vehicle (VehicleID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, Name, PlateNumber, CurrentSelected)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Card (CardID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, CardTypeID INTEGER, CardPreview, CardNumber, CVC, ExpirationDate, ExpDate)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS DefaultCard (DefaultCardID INTEGER NOT NULL)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS ChosenLanguage (LanguageID INTEGER NOT NULL)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS City (CityID INTEGER NOT NULL PRIMARY KEY, Name, Cards, TransactionFeeEnabled, Ordering)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Zone (ZoneID INTEGER NOT NULL PRIMARY KEY, CityID INTEGER, Name, Color, Contact)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS ZoneTariff (ZoneTariffID INTEGER NOT NULL PRIMARY KEY, ZoneID INTEGER, Description, Ordinal INTEGER, Price INTEGER, Currency, MaxQuantity INTEGER, DetailedClientDesc)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS CardType (CardTypeID INTEGER NOT NULL PRIMARY KEY, CardTypeName, TransactionFeeEnabled INTEGER, Active INTEGER)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Template (TemplateID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, VehicleID INTEGER, CityID INTEGER, ZoneID INTEGER, ZoneTariffID INTEGER)",
            [],
            function (tx) {
                tx.executeSql(
                    "ALTER TABLE TEMPLATE ADD COLUMN Quantity INTEGER DEFAULT 1",
                    [],
                    function (tx, results) { },
                    function (tx, error) {
                        //console.log("")
                    }
                );
            }
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS RegID (RegID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, Value, ServerNotified)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS LastSelect (LastSelectID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, CityID INTEGER, ZoneID INTEGER, ZoneTariffID INTEGER)",
            [],
            function (tx) {
                lastSelectDate = "2007-01-01 10:00:00";
                tx.executeSql(
                    "ALTER TABLE LastSelect ADD COLUMN Quantity INTEGER DEFAULT 1",
                    [],
                    function (tx) {
                        tx.executeSql("ALTER TABLE LastSelect ADD COLUMN LastSelectDate DEFAULT '" + lastSelectDate + "'", [], function (tx) { });
                    },
                    function (tx, error) {
                        //console.log("Ima tablice, ali ima i kolone quantity, pa je otišlo u error: " + error.code + ", Opis: " + error.message);
                        if (error.code == 5) {
                            tx.executeSql("ALTER TABLE LastSelect ADD COLUMN LastSelectDate DEFAULT '" + lastSelectDate + "'", [], function (tx) { }, function (tx, error) { });
                        }
                    }
                );
            }
        );
        tx.executeSql("CREATE TABLE IF NOT EXISTS Dictionary (KeyName, Content)");
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS UserAgreement (Value, Agreement)"
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS Language (LanguageID, Name, Ticker)",
            [],
            function (tx) {
                tx.executeSql(
                    "ALTER TABLE Language ADD COLUMN State",
                    [],
                    function (tx, results) { },
                    function (tx, error) {
                        //console.log("")
                    }
                );
            }
        );
        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS LastUpdate (LastUpdateDate)",
            [],
            function (tx) {
                tx.executeSql("SELECT * FROM LastUpdate",
                    [],
                    function (tx, results) {
                        if (results.rows.length == 0) {
                            tx.executeSql(
                                'INSERT INTO LastUpdate (LastUpdateDate) VALUES ("2007-01-01 10:00:00")'
                            );
                        } else {
                            lastUpdateDate = results.rows.item(0).LastUpdateDate;
                        };
                        tx.executeSql('ALTER TABLE LastUpdate ADD COLUMN LastInitialMessageID INTEGER DEFAULT 0', [], function (tx, results) { }, function (tx, error) { });
                    });
            }
        );

        tx.executeSql("CREATE TABLE IF NOT EXISTS CvvRequired (CvvRequired)");

        tx.executeSql("SELECT * FROM CvvRequired", [], function (tx, results) {
            if (results.rows.length == 0) {
                tx.executeSql('INSERT INTO CvvRequired (CvvRequired) VALUES ("1")');
            } else {
                CvvRequired = results.rows.item(0).CvvRequired;
            }
        });

        tx.executeSql(
            "CREATE TABLE IF NOT EXISTS TransactionFee (TransactionFeeID INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, AmountFrom FLOAT, AmountTo FLOAT, FeeAmount FLOAT, FeeCurrencyID INTEGER, TaxPercentage FLOAT, DateValidFrom DATETIME)"
        );

        RefreshLanguages(tx);

        //tx.executeSql("SELECT * FROM Language", [], function (tx, results) {
        //    if (results.rows.length < 7) {
        //        tx.executeSql("DELETE FROM Language", [], function (tx, results) {
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (1, "Hrvatski", "hr")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (2, "English", "en")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (3, "Italiano", "it")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (4, "Slovenščina", "sl")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (5, "Deutsch", "de")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (6, "Français", "fr")'
        //            );
        //            tx.executeSql(
        //              'INSERT INTO Language (LanguageID, Name, Ticker) VALUES (7, "Český", "cz")'
        //            );
        //        });
        //    }
        //});

        db.transaction(function (tx) {
            tx.executeSql("SELECT * FROM ChosenLanguage", [], function (tx, results) {
                if (results.rows.length === 0) {
                    //add required languages
                    showSettings();

                    $("#firstSettingsOK").show();
                    $("#settingsOK").hide();
                }
            });
        });
    }

    function errorCB(tx, err) {
        alertBox("Dogodila se pogreška pri kreiranju strukture baze podataka!", null, "greska", "ok");
    }

    function successCB() {
        console.log("successCB");
        //DetectPlatform();
        //LockOrientation();

        SetLanguageDictionary();

        RegisterDevice(); // registracija uređaja za primanje push notifikacija
        GetCardValidationData();
        RouteAppStart(); // kod pokretanja aplikacije usmjerava ju na odgovarajuću stranicu
    }
}

function RateThisAppConfig() {
    if (deviceOS != "browser") {
        var title = translate("title");
        var message = translate("message");
        var cancelButtonLabel = translate("cancelButtonLabel");
        var laterButtonLabel = translate("laterButtonLabel");
        var rateButtonLabel = translate("rateButtonLabel");
        var yesButtonLabel = translate("yesButtonLabel");
        var noButtonLabel = translate("noButtonLabel");
        var appRatePromptTitle = translate("appRatePromptTitle");
        var feedbackPromptTitle = translate("feedbackPromptTitle");

        AppRate.preferences = {
            displayAppName: "ParkWallet",
            usesUntilPrompt: 10,
            promptAgainForEachNewVersion: false,
            inAppReview: true,
            storeAppURL: {
                ios: "864063246",
                android: "market://details?id=hr.ipt.parkwallet"
            },
            customLocale: {
                title: title,
                message: message,
                cancelButtonLabel: cancelButtonLabel,
                laterButtonLabel: laterButtonLabel,
                rateButtonLabel: rateButtonLabel,
                yesButtonLabel: yesButtonLabel,
                noButtonLabel: noButtonLabel,
                appRatePromptTitle: appRatePromptTitle,
                feedbackPromptTitle: feedbackPromptTitle
            },
            callbacks: {
                handleNegativeFeedback: function () {
                    window.open("mailto:parkwallet@ipt.hr", "_system");
                },
                onRateDialogShow: function (callback) {
                    //callback(1) // cause immediate click on 'Rate Now' button
                },
                onButtonClicked: function (buttonIndex) {
                    console.log("onButtonClicked -> " + buttonIndex);
                }
            }
        };
    }
}

//function SetBackListener(){
// dodajemo event listener za tipku "back"
//if ((document.body.hasAttribute('listener') && document.body.getAttribute('listener') !== 'true') || !document.body.hasAttribute('listener')) {
//    document.addEventListener("backbutton", function () {
//        Back(true);
//        document.body.setAttribute('listener', 'true');
//        alertBox("Listener set!!!", null, "Obavijest", translate("ok"));
//    }, false);
//}
//document.addEventListener("backbutton", function () {
//    Back(true);
//    document.body.setAttribute('listener', 'true');
//    alertBox("Listener set!!!", null, "Obavijest", translate("ok"));
//}, false);
//testing = testing + 1;
//alertBox(testing, null, "Obavijest", translate("ok"));
//}

var testing = 0;

function RateThisAppNow() {
    if (deviceOS != "browser") {
        AppRate.promptForRating();
    }
    //alertBox("Registriramo back button handler", null, "Obavijest", translate("ok"));
    //SetBackListener();
}

function UpdateInitialInfo() {

    var currentdate = new Date();
    var currentDate = currentdate.getFullYear() + '-' + (currentdate.getMonth() + 1) + "-" + currentdate.getDate() + " " + currentdate.getHours() + ":" + currentdate.getMinutes() + ":" + currentdate.getSeconds();

    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM LastSelect",
            [],
            function (tx, results) {

                if (results.rows.length == 1) {
                    var lastSelectDate = results.rows.item(0).LastSelectDate;

                    var cd = Date.parse(currentDate);
                    var lsd = Date.parse(lastSelectDate);

                    const diffTime = cd - lsd;
                    const diffDays = diffTime / (1000 * 60 * 60 * 24);
                    //console.log(diffDays);

                    if (diffDays >= 5) {
                        //spremi novi LastSelectDate - neka to bude za jedan dan uvećan prethodni LastSelectDate
                        //kako ne bismo, ukoliko korisnik ne stisne "P", jedan dan ulazili u LoadInitialInformationNew(1) nakon ovog ulaska
                        var newLsd = lsd + (1000 * 60 * 60 * 24);
                        var newDate = new Date(newLsd);
                        var newLastSelectDate = newDate.getFullYear() + "-" + (newDate.getMonth() + 1) + "-" + newDate.getDate() + " " + newDate.getHours() + ":" + newDate.getMinutes() + ":" + newDate.getSeconds();
                        tx.executeSql("UPDATE LastSelect SET LastSelectDate = '" + newLastSelectDate + "'",
                            [],
                            function (tx) {
                                LoadInitialInformationNew(1);
                            });
                    }
                    else {
                        GetLastUpdateDate();
                    }
                } else {
                    GetLastUpdateDate();
                }


            });
    });

}

function GetLastUpdateDate() {

    $.ajax({
        url: serviceURL + "/api/MobileApi/GetLastUpdateDate",
        type: "POST",
        success: function (results) {
            if (results.Status == 1) {
                results.Message;
                if (results.Message > lastUpdateDate) {
                    db.transaction(function (tx) {
                        tx.executeSql(
                            "UPDATE LastUpdate SET LastUpdateDate = '" +
                            results.Message +
                            "'",
                            [],
                            function (tx) {
                                console.log("LastUpdate update");
                            }
                        );
                    });
                    LoadInitialInformationNew(2);
                }
            }
        },
        error: ajaxError,
        timeout: timeout
    });

}

function GetCvvRequired() {
    $.ajax({
        url: serviceURL + "/api/MobileApi/GetCvvRequired",
        type: "POST",
        success: function (results) {
            if (results.Status == 1) {
                results.Message;
                db.transaction(function (tx) {
                    tx.executeSql(
                        "UPDATE CvvRequired SET CvvRequired = " + results.Message
                    );
                });
                CvvRequired = results.Message;
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}

function GetTransactionFeeDetails() {
    $.ajax({
        url: serviceURL + "/api/MobileApi/GetTransactionFeeDetails",
        type: "POST",
        success: function (results) {
            if (results.Status == 1) {
                db.transaction(function (tx) {
                    tx.executeSql("DELETE FROM TransactionFee", [], function (tx) {
                        for (i = 0; i < results.TransactionFees.length; i++) {
                            var fee = results.TransactionFees[i];
                            tx.executeSql(
                                'INSERT INTO TransactionFee (AmountFrom, AmountTo, FeeAmount, FeeCurrencyID, TaxPercentage, DateValidFrom) VALUES ("' +
                                fee.AmountFrom +
                                '","' +
                                fee.AmountTo +
                                '","' +
                                fee.FeeAmount +
                                '","' +
                                fee.FeeCurrencyID +
                                '","' +
                                fee.TaxPercentage +
                                '","' +
                                fee.DateValidFrom +
                                '")',
                                [],
                                null
                            );
                        }
                    });
                });
            } else {
                db.transaction(function (tx) {
                    tx.executeSql("DELETE FROM TransactionFee", [], null);
                });
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}
var timeout = 15000;
var lang;
var dictionary;
var langId;
var state;
var languageGotFromServer = 0;
var deviceOS = "browser";

function DetectPlatform() {
    deviceOS = "android";

    if (typeof device != "undefined") {
        if (
            device.platform == "ios" ||
            device.platform == "iOS" ||
            device.platform == "IOS"
        )
            deviceOS = "ios";
    } else {
        deviceOS = "browser";
    }
}

function alertBox(message, nesto, title, confirmButton) {
    if (deviceOS === "browser") {
        alert(message);
    } else {
        navigator.notification.alert(message, nesto, title, translate("ok"));
    }
}

function confirmBox(message, title, confirmButton, cancelButton, id, callback) {
    if (deviceOS === "browser") {
        var r = confirm(message);
        if (r) {
            if (id) {
                callback(id);
            } else {
                callback();
            }
        }
    } else {
        if (navigator.notification) {
            navigator.notification.confirm(
                message,
                function (buttonIndex) {
                    if (buttonIndex == 2) {
                        //return true;
                        if (id) {
                            callback(id);
                        } else {
                            callback();
                        }
                    }
                },
                title,
                [cancelButton, confirmButton]
            );
        }
    }
}

function SetLanguageDictionary() {
    lang = "en";
    langId = 2;
    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM ChosenLanguage", [], function (tx, results) {
            if (results.rows.length > 0) {
                tx.executeSql(
                    "SELECT * FROM Language WHERE LanguageID = " +
                    results.rows.item(0).LanguageID,
                    [],
                    function (tx, results1) {
                        lang = results1.rows.item(0).Ticker;
                        langId = results1.rows.item(0).LanguageID;
                        state = results1.rows.item(0).State;
                        updateLanguage();
                        GetUserAgreement(langId);
                        RateThisAppConfig();
                    }
                );
            }
        });
    });
}

function translateLanguages() {
    let language = dictionary.language[lang];
    for (key in language) {
        if (key.length > 0) {
            $("." + key).html(language[key]);
        }
    }
}

function updateLanguage() {
    translateLanguages();

    $("#txtKorisnickoIme").attr("placeholder", translate("korisnicko-ime"));
    $("#txtLozinka").attr("placeholder", translate("lozinka"));

    $("#txtLozinka").attr("placeholder", translate("lozinka"));
    $("#txtPonovljenaLozinka").attr("placeholder", translate("ponovite-lozinku"));
    $("#txtNovaLozinka").attr("placeholder", translate("nova-lozinka"));
    $("#txtEmail").attr("placeholder", translate("email-adresa"));

    $("#txtName").attr("placeholder", translate("ime"));
    $("#txtSurname").attr("placeholder", translate("prezime"));
    $("#txtAddress").attr("placeholder", translate("adresa"));
    $("#txtZip").attr("placeholder", translate("postanski-broj"));
    $("#txtCity").attr("placeholder", translate("grad"));
    $("#txtState").attr("placeholder", translate("drzava"));
    $("#txtPhone").attr("placeholder", translate("telefon"));

    $("#txtNazivVozila").attr("placeholder", translate("naziv-vozila"));
    $("#txtRegistracija").attr("placeholder", translate("reg-oznaka"));

    $("#txtBrojKartice").attr("placeholder", translate("broj-kartice"));
    $("#txtMjesec").attr("placeholder", translate("mjesec"));
    $("#txtGodina").attr("placeholder", translate("godina"));
    $("#txtCVC").attr("placeholder", translate("kontrolni-broj"));
    $("#txtPin").attr("placeholder", translate("vlastiti-pin"));
    $("#txtBrojRacuna").attr("placeholder", translate("broj-racuna")); // mm
    $("#txtAVC").attr("placeholder", translate("kontrolni-broj-racuna")); // mm
}

function translate(key) {
    if (dictionary) {
        return dictionary.language[lang][key];
    }
    return key;
}


// aplikaciju na login stranicu
function clearDBOnly() {

    console.log("Detekcija baze koja nema informaciju o verziji ili je verzija kriva. Brisanje tablica iz ove stare baze.");
    return new Promise((resolve, reject) => {
        db.transaction(function (tx) {
            tx.executeSql("SELECT * FROM User", [], function (tx, results) {
                if (results.rows.length > 0) {
                    var user = results.rows.item(0).Username;
                    console.log("Username u staroj bazi bio je: " + user);
                } else {
                    console.log("U staroj bazi je tablica User prazna");
                };
                tx.executeSql("DROP TABLE IF EXISTS Card", [], function (tx) {
                    tx.executeSql("DROP TABLE IF EXISTS CardType", [], function (tx) {
                        tx.executeSql("DROP TABLE IF EXISTS ChosenLanguage", [], function (tx) {
                            tx.executeSql("DROP TABLE IF EXISTS City", [], function (tx) {
                                tx.executeSql("DROP TABLE IF EXISTS CvvRequired", [], function (tx) {
                                    tx.executeSql("DROP TABLE IF EXISTS DefaultCard", [], function (tx) {
                                        tx.executeSql("DROP TABLE IF EXISTS Dictionary", [], function (tx) {
                                            tx.executeSql("DROP TABLE IF EXISTS Language", [], function (tx) {
                                                tx.executeSql("DROP TABLE IF EXISTS LastSelect", [], function (tx) {
                                                    tx.executeSql("DROP TABLE IF EXISTS LastUpdate", [], function (tx) {
                                                        tx.executeSql("DROP TABLE IF EXISTS RegID", [], function (tx) {
                                                            tx.executeSql("DROP TABLE IF EXISTS Template", [], function (tx) {
                                                                tx.executeSql("DROP TABLE IF EXISTS TransactionFee", [], function (tx) {
                                                                    tx.executeSql("DROP TABLE IF EXISTS User", [], function (tx) {
                                                                        tx.executeSql("DROP TABLE IF EXISTS UserAgreement", [], function (tx) {
                                                                            tx.executeSql("DROP TABLE IF EXISTS Vehicle", [], function (tx) {
                                                                                tx.executeSql("DROP TABLE IF EXISTS Version", [], function (tx) {
                                                                                    tx.executeSql("DROP TABLE IF EXISTS Zone", [], function (tx) {
                                                                                        tx.executeSql("DROP TABLE IF EXISTS ZoneTariff", [], function (tx) {
                                                                                            console.log("Završeno brisanje tablica iz stare baze.");
                                                                                            resolve();
                                                                                        }, function (tx, error) {
                                                                                            console.log("Greška pri brisanju tablica iz stare baze.");
                                                                                            reject();
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
}

// briše sve tablice iz baze i preusmjerava
// aplikaciju na login stranicu
function clearDatabase() {
    DeleteCardsFromDatabase();

    db.transaction(function (tx) {
        tx.executeSql("DELETE FROM User");
        tx.executeSql("DELETE FROM Vehicle");
        tx.executeSql("DELETE FROM Card");
        tx.executeSql("DELETE FROM City");
        tx.executeSql("DELETE FROM Zone");
        tx.executeSql("DELETE FROM ZoneTariff");
        tx.executeSql("DELETE FROM CardType");
        tx.executeSql("DELETE FROM Template");
        tx.executeSql("DELETE FROM LastSelect");
        tx.executeSql("DELETE FROM Dictionary");
        tx.executeSql("DELETE FROM UserAgreement");
        tx.executeSql("DELETE FROM DefaultCard");
        //tx.executeSql("DELETE FROM RegID");
        tx.executeSql("DELETE FROM sqlite_sequence");
        tx.executeSql("DELETE FROM Version");
        //tx.executeSql("DELETE FROM ChosenLanguage");
        //tx.executeSql("DELETE FROM Language");
    });

    RenderView("login.html", "");
}

function clearDatabaseSync(renderView) {

    //language i chosenlanguage se ne brišu

    db.transaction(function (tx) {
        tx.executeSql("DELETE FROM Card", [], function () {
            tx.executeSql("DELETE FROM CardType", [], function () {
                tx.executeSql("DELETE FROM City", [], function () {
                    tx.executeSql("DELETE FROM CvvRequired", [], function () {
                        tx.executeSql("DELETE FROM DefaultCard", [], function () {
                            tx.executeSql("DELETE FROM Dictionary", [], function () {
                                tx.executeSql("DELETE FROM LastSelect", [], function () {
                                    tx.executeSql("DELETE FROM LastUpdate", [], function () {
                                        tx.executeSql("DELETE FROM RegID", [], function () {
                                            tx.executeSql("DELETE FROM Template", [], function () {
                                                tx.executeSql("DELETE FROM TransactionFee", [], function () {
                                                    tx.executeSql("DELETE FROM User", [], function () {
                                                        tx.executeSql("DELETE FROM UserAgreement", [], function () {
                                                            tx.executeSql("DELETE FROM Vehicle", [], function () {
                                                                tx.executeSql("DELETE FROM Version", [], function () {
                                                                    tx.executeSql("DELETE FROM Zone", [], function () {
                                                                        tx.executeSql("DELETE FROM ZoneTariff", [], function () {
                                                                            tx.executeSql("DELETE FROM sqlite_sequence", [], function () {
                                                                                if (renderView == true) {
                                                                                    RenderView("login.html", "");
                                                                                };
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
}

function logoutCallback() {
    db.transaction(function (tx) {
        tx.executeSql("UPDATE User SET IsLogin == 'false'");
        RenderView("login.html", "");
    });
}

function logout() {
    confirmBox(
        translate("odjava-pitanje"),
        translate("Odjava"),
        translate("siguran-sam"),
        translate("odustani"),
        null,
        logoutCallback
    );
}

// briše sve tablice iz baze i preusmjerava
// aplikaciju na login stranicu
function clearSettings() {
    confirmBox(
        translate("brisati-postavke"),
        translate("brisanje-postavki-title"),
        translate("siguran-sam"),
        translate("odustani"),
        null,
        clearSettingsCallback
    );
}

function clearSettingsCallback() {
    clearDatabaseSync(true);
}

// upisuje korisnika u bazu
function SetUser(username, guid) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    tx.executeSql("UPDATE User SET IsLogin = 'true', Username = '" + username + "', GUID = '" + guid + "'");
                    if (results.rows.item(0).IsWizardComplete == "true") {
                        RenderView("home.html", "");
                    } else {
                        RenderView("addvehiclewizard.html", "");
                    }
                } else {
                    tx.executeSql('INSERT INTO User (Username, Password, GUID, IsWizardComplete, IsLogin) VALUES ("' + username + '","********", "' + guid + '", "true", "true")',
                        [],
                        function (tx) {
                            tx.executeSql("UPDATE ChosenLanguage SET LanguageID = " + langId, [], function (tx) {
                                SetLanguageDictionary();
                            });
                        });

                    RenderView("addvehiclewizard.html", "");
                }
            },
            null
        );
    });
}

// dodaje RegID u bazu
function AddRegID(value) {
    //alertBox('AddRegID');
    db.transaction(function (tx) {
        tx.executeSql(
            "INSERT INTO RegID (Value, ServerNotified) VALUES ('" +
            value +
            "', 'false')",
            [],
            function () {
                UpdateNotificationRegIDOnServer();
            },
            null
        );
    });
}

function OnClickUpisatCuKasnije() {
    db.transaction(function (tx) {
        tx.executeSql("UPDATE User SET IsWizardComplete = 'true'");
        RenderView("home.html", "");
        ArePushNotificationsEnabled();
    });
}

function ArePushNotificationsEnabled() {
    if (deviceOS == "iOS") {
        cordova.exec(
            function callback(data) {
                if (data == false) {
                    //navigator.notification.alert("Za potpunu funkcionalnost aplikacije, molimo Vas da uključite obavijesti aplikacije u postavkama uređaja.", null, "Obavijest", translate("ok"));

                    alertBox(
                        translate("notification-info"),
                        null,
                        translate("obavijest"),
                        translate("ok")
                    );
                }
            },
            function errorHandler(err) { },
            "CheckIsNotificationEnabled",
            "isNotificationEnabled",
            []
        );
    }
}

var isWizard;
var isVechicleWizard;

// kriptira podatke o kartici/računu i upisuje ih u bazu
function AddCard(IsWizard) {
    isWizard = IsWizard;
    var cardTypeID = $("#ddlTipoviKartica").val();

    // new code
    db.transaction(function (tx) {
        tx.executeSql(`SELECT IsAccount FROM CardType WHERE CardTypeID = ${cardTypeID}`, [], function (tx, results) {
            if (results.rows.length == 1) {
                let isAccount = results.rows[0].IsAccount;
                
                if (!isAccount) {
                    SaveCard(cardTypeID);
                } else {
                    SaveAccount(cardTypeID);
                }
            }
        });
    });
    // new code END
}

function SaveCard(cardTypeID) {
    var cardNumber = $("#txtBrojKartice").val();
    var cvc = $("#txtCVC").val();
    var month = $("#txtMjesec").val();
    var year = $("#txtGodina").val();
    var expirationDate = year + month;
    var pin = $("#txtPin").val();

    if (CvvRequired == 0) {
        cvc = "000";
    }

    if (
        (cardNumber != "" &&
            cvc != "" &&
            month != "" &&
            year != "" &&
            pin != "" &&
            cardTypeID != "5") ||
        (cardNumber != "" &&
            month != "" &&
            year != "" &&
            pin != "" &&
            cardTypeID === "5")
    ) {

        validateCardOnType(cardNumber, parseInt(cardTypeID))
            .then((isCardTypeValid) => {
                if (isCardTypeValid) {
                    if (ValidateCvv(cvc, cardTypeID)) {
                        if (ValidateMonth(month)) {
                            if (ValidateYear(year)) {
                                if (ValidateMonthAndYear(parseInt(month), parseInt(year))) {
                                    if (isNaN(pin)) {
                                        alertBox(
                                            translate("neispravan-pin-brojevi"),
                                            null,
                                            translate("upozorenje"),
                                            translate("ok")
                                        );
                                    } else if (pin.length < 4 || pin.length > 8) {
                                        alertBox(
                                            translate("neispravan-pin-min-max"),
                                            null,
                                            translate("upozorenje"),
                                            translate("ok")
                                        );
                                    } else {
                                        db.transaction(function (tx) {
                                            tx.executeSql(
                                                "SELECT * FROM Card WHERE CardTypeID = " + cardTypeID,
                                                [],
                                                function (tx, results) {
                                                    if (results.rows.length > 0) {
                                                        //već imamo karticu ovog tipa
                                                        alertBox(
                                                            translate("kartica-vec-postoji"),
                                                            null,
                                                            translate("upozorenje"),
                                                            translate("ok")
                                                        );
                                                    } else {
                                                        confirmBox(
                                                            translate("dali-su-podaci-tocni"),
                                                            translate("upozorenje"),
                                                            translate("siguran-sam"),
                                                            translate("odustani"),
                                                            null,
                                                            AddCardCallback
                                                        );
                                                    }
                                                }
                                            );
                                        });

                                        //        navigator.notification.confirm(
                                        //translate("dali-su-podaci-tocni") ,
                                        //function (buttonIndex) {
                                        //    if (buttonIndex == 2) {

                                        //    }
                                        //},
                                        //    translate('upozorenje'),
                                        //    [translate('odustani'), translate('siguran-sam')]
                                        //);
                                    }
                                } else {
                                    alertBox(
                                        translate("pohrana-istek-kartice"),
                                        null,
                                        translate("upozorenje"),
                                        translate("ok")
                                    );
                                }
                            } else {
                                alertBox(
                                    translate("format-godine"),
                                    null,
                                    translate("upozorenje"),
                                    translate("ok")
                                );
                            }
                        } else {
                            alertBox(
                                translate("format-mjesec"),
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                        }
                    } else {
                        alertBox(
                            translate("neispravan-kontrolni-broj"),
                            null,
                            translate("upozorenje"),
                            translate("ok")
                        );
                    }
                } else {
                    alertBox(
                        translate("neispravan-broj-kartice"),
                        null,
                        translate("upozorenje"),
                        translate("ok")
                    );
                }
            })
    } else {
        alertBox(
            translate("svi-podaci-su-obavezni"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
    }
}

function AddCardCallback() {
    var cardTypeID = $("#ddlTipoviKartica").val();
    var cardNumber = $("#txtBrojKartice").val();
    var cvc = $("#txtCVC").val();
    var month = $("#txtMjesec").val();
    var year = $("#txtGodina").val();
    var expirationDate = year + month;
    var pin = $("#txtPin").val();
    cardNumberCrypted = crypt(cardNumber, pin);
    cvcCrypted = crypt(cvc, pin);
    expirationDateCrypted = crypt(expirationDate, pin);
    var expirationCardNotify = $("#expirationCardNotify").prop("checked");

    //if ($("#expirationCardNotify").prop('checked') == true) {

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/UpdateCard",
                        type: "POST",
                        data: {
                            GUID: guid,
                            Action: 1,
                            CardTypeID: cardTypeID,
                            ExpirationDate: expirationDate,
                            ExpirationCardNotify: expirationCardNotify // in case of account null
                        },
                        success: function (results) {
                            if (results.Status == 1) {
                                InsertCard(
                                    isWizard,
                                    cardTypeID,
                                    cardNumber,
                                    cardNumberCrypted,
                                    cvcCrypted,
                                    expirationDateCrypted,
                                    month + "/20" + year
                                );
                                HideLoading();
                            }
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });

    //} else {
    //    InsertCard(isWizard, cardTypeID, cardNumber, cardNumberCrypted, cvcCrypted, expirationDateCrypted, month + "/20" + year);
    //}
}

function InsertCard(
    IsWizard,
    cardTypeID,
    cardNumber,
    cardNumberCrypted,
    cvcCrypted,
    expirationDateCrypted,
    expirationDate
) {
    db.transaction(function (tx) {
        tx.executeSql(
            "INSERT INTO Card (CardTypeID, CardPreview, CardNumber, CVC, ExpirationDate, ExpDate) VALUES (" +
            cardTypeID +
            ',"' +
            cardNumber.substring(0, 2) +
            "XX XXXX XXXX " +
            cardNumber.substring(cardNumber.length - 4, cardNumber.length) +
            '","' +
            cardNumberCrypted +
            '","' +
            cvcCrypted +
            '","' +
            expirationDateCrypted +
            '", "' +
            expirationDate +
            '")',
            [],
            function () {
                tx.executeSql("SELECT * FROM Card", [], function (tx, results) {
                    if (results.rows.length > 0) {
                        var lastCardID = results.rows.item(results.rows.length - 1).CardID;
                        tx.executeSql("DELETE FROM DefaultCard", [], function (tx, results) {
                            tx.executeSql(
                                "INSERT INTO DefaultCard VALUES (" + lastCardID + ")"
                            );

                            if (IsWizard) {
                                RenderView("home.html", "");
                                tx.executeSql("UPDATE User SET IsWizardComplete = 'true'");
                                IsPushNotificationIsEnabled();
                            } else {
                                if (callStack.indexOf("newpayment.html") == -1) {
                                    RenderView("home.html", "");
                                } else {
                                    Back(false);
                                }
                            }
                        });
                    }
                });
            },
            null
        );
    });
}

// briše podatke o kreditnoj kartici iz baze
function RemoveCard(CardID, querySuccess, errorCB) {
    navigator.notification.confirm(
        "Jeste li sigurni da želite obrisati podatke o upisanoj kreditnoj kartici?",
        function (buttonIndex) {
            if (buttonIndex == 2) {
                db.transaction(function (tx) {
                    tx.executeSql("DELETE FROM Card WHERE CardID = " + CardID);
                });
            }
        },
        translate("upozorenje"),
        ["Odustani", "Siguran sam"]
    );
}

// ACCOUNT metode BEGIN
function SaveAccount(cardTypeID) {
    var accountID = $("#txtBrojRacuna").val();
    var avc = $("#txtAVC").val();
    var pin = $("#txtPin").val();
    
    if (accountID != "" && avc != "" && pin != "") {
        validateCardOnType(accountID, parseInt(cardTypeID))
            .then((isCardTypeValid) => {
                if (isCardTypeValid) {
                    if (ValidateAvc(avc)) {
                        if (isNaN(pin)) {
                            alertBox(
                                translate("neispravan-pin-brojevi"),
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                        } else if (pin.length < 4 || pin.length > 8) {
                            alertBox(
                                translate("neispravan-pin-min-max"),
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                        } else {
                            db.transaction(function (tx) {
                                tx.executeSql(
                                    "SELECT * FROM Card WHERE CardTypeID = " + cardTypeID,
                                    [],
                                    function (tx, results) {
                                        if (results.rows.length > 0) {
                                            //već imamo račun ovog tipa
                                            alertBox(
                                                translate("racun-vec-postoji"),
                                                null,
                                                translate("upozorenje"),
                                                translate("ok")
                                            );
                                        } else {
                                            confirmBox(
                                                translate("dali-su-podaci-tocni"),
                                                translate("upozorenje"),
                                                translate("siguran-sam"),
                                                translate("odustani"),
                                                null,
                                                AddAccountCallback
                                            );
                                        }
                                    }
                                );
                            });
                        }
                    } else {
                        alertBox(
                            translate("neispravan-kontrolni-broj-racuna"),
                            null,
                            translate("upozorenje"),
                            translate("ok")
                        );
                    }
                } else {
                    alertBox(
                        translate("neispravan-broj-racuna"),
                        null,
                        translate("upozorenje"),
                        translate("ok")
                    );
                }
            });
    } else {
        alertBox(
            translate("svi-podaci-su-obavezni"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
    }
}

function AddAccountCallback() {
    var cardTypeID = $("#ddlTipoviKartica").val();
    var accountID = $("#txtBrojRacuna").val();
    var avc = $("#txtAVC").val();
    var pin = $("#txtPin").val();
    var accountIdCrypted = crypt(accountID, pin);
    var avcCrypted = crypt(avc, pin);
    
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/AccountApi/UpdateAccount",
                        type: "POST",
                        data: {
                            GUID: guid,
                            Action: 1,
                            CardTypeID: cardTypeID
                        },
                        success: function (results) {
                            if (results.Status == 1) {
                                InsertAccount(
                                    isWizard,
                                    cardTypeID,
                                    accountID,
                                    accountIdCrypted,
                                    avcCrypted
                                );
                                HideLoading();
                            }
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });
}

function InsertAccount(
    IsWizard,
    cardTypeID,
    accountID,
    accountIdCrypted,
    avcCrypted
) {
    db.transaction(function (tx) {
        tx.executeSql(
            "INSERT INTO Card (CardTypeID, CardPreview, CardNumber, CVC, ExpirationDate, ExpDate) VALUES (" +
            cardTypeID +
            ',"' +
            accountID.substring(0, 2) +
            "XX XXXX XXXX " +
            accountID.substring(accountID.length - 4, accountID.length) +
            '","' +
            accountIdCrypted +
            '","' +
            avcCrypted +
            '","' +
            null +
            '", "' +
            null +
            '")',
            [],
            function () {
                tx.executeSql("SELECT * FROM Card", [], function (tx, results) {
                    if (results.rows.length > 0) {
                        var lastCardID = results.rows.item(results.rows.length - 1).CardID;
                        tx.executeSql("DELETE FROM DefaultCard", [], function (tx, results) {
                            tx.executeSql(
                                "INSERT INTO DefaultCard VALUES (" + lastCardID + ")"
                            );

                            if (IsWizard) {
                                RenderView("home.html", "");
                                tx.executeSql("UPDATE User SET IsWizardComplete = 'true'");
                                IsPushNotificationIsEnabled();
                            } else {
                                if (callStack.indexOf("newpayment.html") == -1) {
                                    RenderView("home.html", "");
                                } else {
                                    Back(false);
                                }
                            }
                        });
                    }
                });
            },
            null
        );
    });
}
// ACCOUNT metode END

// zahtjev za transakcijom preko predloška
function TemplatePayment(templateID, step) {
    if (step == 1) {
        templateID = selectedTemplateID;
    } else {
        selectedTemplateID = templateID;
    }

    var guid;
    var ticket;
    var zoneTariffID;
    var cardTypeID;
    var ctId;
    var cardNumber;
    var expirationDate;
    var cvc;
    var vehicleID;
    var cityID;
    var quantity;

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Template WHERE TemplateID = " + templateID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    zoneTariffID = results.rows.item(0).ZoneTariffID;
                    vehicleID = results.rows.item(0).VehicleID;
                    cityID = results.rows.item(0).CityID;
                    quantity = results.rows.item(0).Quantity;
                    tx.executeSql(
                        "SELECT * FROM User",
                        [],
                        function (tx, results) {
                            if (results.rows.length > 0) {
                                guid = results.rows.item(0).GUID;
                                tx.executeSql(
                                    "SELECT * FROM Vehicle WHERE VehicleID = " + vehicleID,
                                    [],
                                    function (tx, results) {
                                        if (results.rows.length > 0) {
                                            ticket = results.rows.item(0).PlateNumber;
                                            tx.executeSql(
                                                "SELECT * FROM Card INNER JOIN DefaultCard ON Card.CardID = DefaultCard.DefaultCardID",
                                                [],
                                                function (tx, results) {
                                                    if (results.rows.length > 0) {
                                                        if (step == 0) {
                                                            RepeatRegister();
                                                            $("footer").show();
                                                            $(".templatepaymentStep2").show();
                                                            $(".newpaymentpin").show();
                                                            $("#templates").hide();
                                                            $("footer").css("height", "auto");
                                                            $(".titleText").html(translate("placanje"));
                                                            $("#wrapper")
                                                                .css("margin-bottom", "-203px")
                                                                .css("padding-bottom", "203px");
                                                            ctId = results.rows.item(0).CardTypeID;
                                                            ShowTransactionPrice(
                                                                zoneTariffID,
                                                                ctId,
                                                                cityID,
                                                                quantity
                                                            );
                                                            return;
                                                        }

                                                        cardTypeID = results.rows.item(0).CardTypeID;
                                                        cardNumber = decrypt(
                                                            results.rows.item(0).CardNumber,
                                                            $("#txtPin").val()
                                                        );
                                                        expirationDate = decrypt(
                                                            results.rows.item(0).ExpirationDate,
                                                            $("#txtPin").val()
                                                        );
                                                        cvc = decrypt(
                                                            results.rows.item(0).CVC,
                                                            $("#txtPin").val()
                                                        );

                                                        validateCardOnType(cardNumber, cardTypeID)
                                                            .then((isCardTypeValid) => {
                                                                if (isCardTypeValid) {
                                                                    TransactionRequest(
                                                                        guid,
                                                                        ticket,
                                                                        zoneTariffID,
                                                                        cardTypeID,
                                                                        cardNumber,
                                                                        expirationDate,
                                                                        cvc,
                                                                        quantity
                                                                    );
                                                                } else {
                                                                    $("#txtPin").val("");
                                                                    $("#maskPin").empty();

                                                                    failedAttempt++;

                                                                    if (failedAttempt >= 3) {
                                                                        failedAttempt = 0;
                                                                        DeleteCardsFromDatabase();
                                                                        alertBox(
                                                                            translate("maximalan-broj-pokusaja"),
                                                                            null,
                                                                            translate("upozorenje"),
                                                                            translate("ok")
                                                                        );
                                                                    } else {
                                                                        alertBox(
                                                                            translate("upisali-ste-neispravan-pin"),
                                                                            null,
                                                                            translate("upozorenje"),
                                                                            translate("ok")
                                                                        );
                                                                    }
                                                                }
                                                            })
                                                    } else {
                                                        RenderView("addcard.html", CurrentView);
                                                    }
                                                },
                                                null
                                            );
                                        }
                                    },
                                    null
                                );
                            }
                        },
                        null
                    );
                }
            },
            null
        );
    });
}

// dodaje novi predložak u bazu
function AddTemplate() {
    var vehicleID = parseInt($("#ddlVozila").val());
    var cityID = parseInt($("#ddlGradovi").val());
    var zoneID = parseInt($("#ddlZone").val());
    var zoneTariffID = parseInt($("#ddlTarife").val());
    var quantity = parseInt($("#quantity").html());

    if (cityID == 0) {
        alertBox(
            translate("nije-odabran-grad"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Template WHERE VehicleID = " +
            vehicleID +
            " AND CityID = " +
            cityID +
            " AND ZoneID = " +
            zoneID +
            " AND ZoneTariffID = " +
            zoneTariffID +
            " AND Quantity = " +
            quantity,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    alertBox(
                        translate("spremljeni-predlozak-postoji"),
                        null,
                        translate("upozorenje"),
                        translate("ok")
                    );
                } else {
                    tx.executeSql(
                        "INSERT INTO Template (VehicleID, CityID, ZoneID, ZoneTariffID, Quantity) VALUES (" +
                        vehicleID +
                        "," +
                        cityID +
                        "," +
                        zoneID +
                        "," +
                        zoneTariffID +
                        "," +
                        quantity +
                        ")",
                        [],
                        function () {
                            //toastr.options = {
                            //  debug: false,
                            //  positionClass: "toast-top-full-width",
                            //  onclick: function() {
                            //    RenderView("templates.html", "newpayment.html");
                            //  },
                            //  fadeIn: 200,
                            //  fadeOut: 200,
                            //  timeOut: 1000,
                            //  extendedTimeOut: 1000
                            //};

                            //toastr.success(translate("dodali-ste-novi-predlozak"));
                            alertBox(
                                translate("dodali-ste-novi-predlozak"),
                                null,
                                translate("obavijest"),
                                translate("ok")
                            );
                        },
                        null
                    );
                }
            },
            null
        );
    });
}

function RepeatRegister() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM RegID",
            [],
            function (tx, results) {
                if (results.rows.length == 0) {
                    RegisterDevice();
                }
            },
            null
        );
    });
}

function enterPin(number) {
    $("#cursor").hide();
    $("#txtPin").val($("#txtPin").val() + number);
    $("#maskPin").append("*");
}

function deletePin() {
    var text = $("#txtPin").val();
    var mask = $("#maskPin").text();

    if (text.length > 0) {
        $("#txtPin").val(text.substring(0, text.length - 1));
    }
    if (mask.length > 0) {
        $("#maskPin").empty();
        $("#maskPin").append(mask.substring(0, mask.length - 1));
    }
    if ($("#maskPin").text() === "") {
        $("#cursor").show();
    }
}

// zahtjev za transakcijom kroz standardni izbornik
function ConfirmPayment(step) {
    paymentStep = step;
    if (cardIsSupported) {
        var vehicleID = parseInt($("#ddlVozila").val());
        var cityID = parseInt($("#ddlGradovi").val());
        var zoneID = parseInt($("#ddlZone").val());
        var tariffID = parseInt($("#ddlTarife").val());
        var quantity = parseInt($("#quantity").html());
        var GUID;
        var Ticket;
        var CardTypeID;
        var ctId;
        var CardName;
        var CardNumber;
        var CVC;
        var ExpirationDate;
        var pin = $("#txtPin").val();

        if (paymentStep == 0 && cityID == 0) {
            alertBox(
                translate("nije-odabran-grad"),
                null,
                translate("upozorenje"),
                translate("ok")
            );
            return;
        }

        if (isNaN(vehicleID)) {
            RenderView("addvehicle.html", "newpayment.html");
            return;
        }

        db.transaction(function (tx) {
            tx.executeSql(
                "SELECT * FROM User",
                [],
                function (tx, results) {
                    if (results.rows.length > 0) {
                        GUID = results.rows.item(0).GUID;
                        tx.executeSql(
                            "SELECT * FROM Vehicle WHERE VehicleID = " + vehicleID,
                            [],
                            function (tx, results) {
                                if (results.rows.length > 0) {
                                    Ticket = results.rows.item(0).PlateNumber;
                                    tx.executeSql(
                                        "SELECT * FROM Card INNER JOIN DefaultCard ON Card.CardID = DefaultCard.DefaultCardID",
                                        [],
                                        function (tx, results) {
                                            if (results.rows.length > 0) {
                                                if (step == 0) {
                                                    paymentStep = 1;
                                                    RepeatRegister();
                                                    $(".newpaymentStep1").hide();
                                                    $(".newpaymentStep2").show();
                                                    $(".newpaymentitems").hide();
                                                    $(".newpaymentpin").show();
                                                    $("footer").css("height", "auto");
                                                    $("#wrapper")
                                                        .css("margin-bottom", "-203px")
                                                        .css("padding-bottom", "203px");
                                                    ctId = results.rows.item(0).CardTypeID;
                                                    ShowTransactionPrice(
                                                        tariffID,
                                                        ctId,
                                                        cityID,
                                                        quantity
                                                    );
                                                    return;
                                                }

                                                if (pin.length == 0) {
                                                    alertBox(
                                                        translate("pin-za-potvrdu"),
                                                        null,
                                                        translate("upozorenje"),
                                                        translate("ok")
                                                    );
                                                } else if (pin.length < 4) {
                                                    alertBox(
                                                        translate("neispravan-pin-min-max"),
                                                        null,
                                                        translate("upozorenje"),
                                                        translate("ok")
                                                    );
                                                } else {
                                                    if (!paymentInProgress) {
                                                        CardTypeID = results.rows.item(0).CardTypeID;
                                                        CardName = results.rows.item(0).Name;
                                                        CardNumber = decrypt(
                                                            results.rows.item(0).CardNumber,
                                                            pin
                                                        );
                                                        CVC = decrypt(results.rows.item(0).CVC, pin);
                                                        ExpirationDate = decrypt(
                                                            results.rows.item(0).ExpirationDate,
                                                            pin
                                                        );

                                                        validateCardOnType(CardNumber, CardTypeID)
                                                            .then(isCardTypeValid => {
                                                                if (isCardTypeValid) {
                                                                    paymentInProgress = true;
                                                                    TransactionRequest(
                                                                        GUID,
                                                                        Ticket,
                                                                        tariffID,
                                                                        CardTypeID,
                                                                        CardNumber,
                                                                        ExpirationDate,
                                                                        CVC,
                                                                        quantity
                                                                    );
                                                                } else {
                                                                    $("#txtPin").val("");
                                                                    $("#maskPin").empty();

                                                                    failedAttempt++;

                                                                    if (failedAttempt >= 3) {
                                                                        failedAttempt = 0;
                                                                        DeleteCardsFromDatabase();
                                                                        alertBox(
                                                                            translate("maximalan-broj-pokusaja"),
                                                                            null,
                                                                            translate("upozorenje"),
                                                                            translate("ok")
                                                                        );
                                                                    } else {
                                                                        alertBox(
                                                                            translate("upisali-ste-neispravan-pin"),
                                                                            null,
                                                                            translate("upozorenje"),
                                                                            translate("ok")
                                                                        );
                                                                    }
                                                                }
                                                            })
                                                    }
                                                }
                                            } else {
                                                RenderView("addcard.html", "newpayment.html");
                                            }
                                        },
                                        null
                                    );
                                }
                            },
                            null
                        );
                    }
                },
                null
            );
        });
    } else {
        // kartica nije validna - obavijest
        alertBox(
            translate("kartica-nije-podrzana") +
            translate("podrzane-kreditne-kartice") +
            supportedCards +
            ".",
            null,
            translate("obavijest"),
            translate("ok")
        );
    }
}

var mobAdsEnabled = 0;

function TransactionRequest(
    GUID,
    Ticket,
    tariffID,
    CardTypeID,
    CardNumber,
    ExpirationDate,
    CVC,
    quantity
) {
    failedAttempt = 0;
    ShowLoading();
    // 1. Korak Transaction Requesta:
    $.ajax({
        url: serviceURL + "/api/MobileApi/TransactionRequest",
        type: "POST",
        data: {
            Step: 1,
            TransactionID: 0,
            GUID: GUID,
            Ticket: Ticket,
            ZoneTariffID: tariffID,
            CardTypeID: CardTypeID,
            Quantity: quantity
        },
        success: function (results) {
            if (results.Status == 1) {
                // 2. korak
                // potrebno je zakriptirati podatke o kartici donjim kripto ključem
                var key = results.CryptoKey;
                CardNumber = crypt(CardNumber, key);
                CVC = crypt(CVC, key);
                ExpirationDate = crypt(ExpirationDate, key);

                $.ajax({
                    url: serviceURL + "/api/MobileApi/TransactionRequest",
                    type: "POST",
                    data: {
                        Step: 2,
                        TransactionID: results.TransactionID,
                        GUID: GUID,
                        CardDetails: CardNumber,
                        ExpirationDate: ExpirationDate,
                        CardVerificationData: CVC
                    },
                    success: function (results) {
                        if (results.Status == 1) {
                            ClearCallStack();
                            notificationWait = setTimeout(function () {
                                if ($("#overflow").css("display") === "block") {
                                    HideLoading();
                                    RenderView("history.html", "home.html");
                                }
                            }, 10000);
                        } else {
                            switch (results.Code) {
                                case -4:
                                case -5:
                                    alertBox(
                                        translate("transakcija-greska-u-obradi"),
                                        null,
                                        translate("obavijest"),
                                        translate("ok")
                                    );
                                    break;
                            }
                            Back(false);
                        }

                        paymentInProgress = false;
                    },
                    error: function (jqXHR, exception) {
                        paymentInProgress = false;
                        ajaxError(jqXHR, exception);
                    }
                });
            } else {
                ClearCallStack();
                HideLoading();
                paymentInProgress = false;
                RenderView("home.html", "");

                switch (results.Code) {
                    case -1:
                        alertBox(
                            translate("korisnicki-racun-je-deaktiviran"),
                            null,
                            translate("obavijest"),
                            translate("ok")
                        );
                        logout();
                        break;
                    case -2:
                        alertBox(
                            translate("neaktivna-zona"),
                            null,
                            translate("obavijest"),
                            translate("ok")
                        );
                        break;
                    case -3:
                        alertBox(
                            translate("zahtjev-za-transakciju-greska"),
                            null,
                            translate("obavijest"),
                            translate("ok")
                        );
                        break;
                    default:
                        alertBox(results.Message, null, translate("obavijest"), translate("ok"));
                }
            }
        },
        error: function (jqXHR, exception) {
            paymentInProgress = false;
            ajaxError(jqXHR, exception);
        }
    });
}

var bannerActive = false;
var adOptions;
var admobidPro;


function GetSaldo(cardId) {

    let pin = $("#getSaldoPIN").val();
    let AccountDetails = '';
    let AVC = '';
    let CardTypeID = null;
    let GUID = '';

    if (pin.length < 4) {
        alertBox(
            translate("neispravan-pin-min-max"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
    } else {
        if (!balanceRequestInProgress && isGetSaldoPINInputValid) { 
            ShowLoading();

            let getCard = new Promise((resolve, reject) => {
                db.transaction(function (tx) {
                    tx.executeSql(`SELECT * FROM Card inner join CardType on Card.CardTypeID = CardType.CardTypeID WHERE Card.CardID =  ${cardId}`, [], function (tx, results) {

                        if (results.rows.length == 1) {
                            let row = results.rows[0];

                            resolve({ accountIdCrypted: row.CardNumber, avcCrypted: row.CVC, cardTypeID: row.CardTypeID });
                        }
                    });
                });
            });

            let getUser = new Promise((resolve, reject) => {
                db.transaction(function (tx) {
                    tx.executeSql(`SELECT * FROM User`, [], function (tx, results) {

                        if (results.rows.length == 1) {
                            let row = results.rows[0];

                            resolve({ GUID: row.GUID });
                        }
                    });
                });
            });


            getCard.then(res => {
                CardTypeID = res.cardTypeID
                AccountDetails = decrypt(res.accountIdCrypted, pin);
                AVC = decrypt(res.avcCrypted, pin);
            })
                .then(() => getUser)
                .then(res => {
                    GUID = res.GUID;
                })
                .then(() => {

                //provjeriti da li ovi podaci imaju smisla?
                    validateCardOnType(AccountDetails, CardTypeID)
                    .then(dataValid => {
                        if (!dataValid) {
                            alertBox(
                                translate("upisali-ste-neispravan-pin"),
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                            HideLoading();
                        }
                        else {

                            let breq_1 = {
                                Step: 1,
                                CardTypeID: CardTypeID,
                                GUID: GUID
                            };

                            let url = serviceURL + "/api/AccountApi/BalanceRequest";

                            $.ajax({
                                type: "POST",
                                data: breq_1,
                                dataType: "JSON", // rtn
                                url: url,
                            })
                                .done((response, textStatus, xhr) => {
                                    if (response.Status == 1) {
                                        //2. korak
                                        //potrebno je zakriptirati podatke o kartici donjim kripto ključem

                                        var key = response.CryptoKey;

                                        let breq_2 = {
                                            Step: 2,
                                            BalanceRequestID: response.BalanceRequestID,
                                            AccountDetails: crypt(AccountDetails, key),
                                            AVC: crypt(AVC, key),
                                            GUID: GUID
                                        };


                                        $.ajax({
                                            type: "POST",
                                            data: breq_2,
                                            dataType: "JSON", // rtn
                                            url: url,
                                        })
                                            .done((response, textStatus, xhr) => {
                                                if (response.Status == 1) {
                                                    ClearCallStack();
                                                    balanceRequestInProgress = true;
                                                    notificationWait = setTimeout(function () {
                                                        if ($("#overflow").css("display") === "block") {
                                                            HideLoading();
                                                            RenderView("historynotif.html", "home.html");
                                                        }
                                                    }, 10000);
                                                } else {
                                                    switch (response.Code) {
                                                        case -4:
                                                        case -5:
                                                            alertBox(
                                                                translate("stanje-na-racunu-greska-u-obradi"),
                                                                null,
                                                                translate("obavijest"),
                                                                translate("ok")
                                                            );
                                                            break;
                                                    }
                                                    Back(false);
                                                }


                                            })
                                            .fail((xhr, status, error) => {
                                                ajaxError(xhr, error);
                                            })
                                            .always(function (jqXHR, textStatus) {
                                                balanceRequestInProgress = false;
                                            });
                                        // 2 end
                                    } else {
                                        ClearCallStack();
                                        HideLoading();
                                        balanceRequestInProgress = false;
                                        RenderView("home.html", "");

                                        switch (response.Code) {
                                            case -1:
                                                alertBox(
                                                    translate("korisnicki-racun-je-deaktiviran"),
                                                    null,
                                                    translate("obavijest"),
                                                    translate("ok")
                                                );
                                                logout();
                                                break;
                                            case -3:
                                                alertBox(
                                                    translate("zahtjev-za-stanje-na-racunu-greska"),
                                                    null,
                                                    translate("obavijest"),
                                                    translate("ok")
                                                );
                                                break;
                                            default:
                                                alertBox(response.Message, null, translate("obavijest"), translate("ok"));
                                        }
                                    }
                                })
                                .fail((xhr, status, error) => {
                                    ajaxError(xhr, error);
                                })
                                .always(function (jqXHR, textStatus) {
                                    balanceRequestInProgress = false;
                                });

                        }
                    }).catch(e => {
                        alertBox(
                                translate("stanje-na-racunu-greska-u-obradi"),
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                        HideLoading();
                        console.log(e);
                    });

                })
                .catch(err => { balanceRequestInProgress = false; });
        }
    }
}

function initAds() {
    var ad_units = {
        ios: {
            banner: 'ca-app-pub-5999567779754117/4364010018',
            interstitial: 'ca-app-pub-5999567779754117/6699169941'
        },
        android: {
            banner: 'ca-app-pub-5999567779754117/4998434831',
            interstitial: 'ca-app-pub-5999567779754117/4348338777'
        }
    };

    admobidPro = {};

    if (/(android)/i.test(navigator.userAgent)) {
        admobidPro = ad_units.android;
    } else if (/(iphone|ipad)/i.test(navigator.userAgent)) {
        admobidPro = ad_units.ios;
    } else {
        admobidPro = ad_units.android;
    }

}

function destroyAdBanner() {
    if (bannerActive) {
        bannerActive = false;
        if (typeof AdMob != 'undefined' && AdMob) {
            AdMob.removeBanner();
        };
    }
};

function displayAd(type) {

    if (typeof AdMob != 'undefined' && AdMob) {
        db.transaction(function (tx) {
            tx.executeSql("SELECT * FROM Dictionary WHERE KeyName = 'MobAdsEnabled'",
                [],
                function (tx, results) {
                    if (results.rows.length > 0) {
                        mobAdsEnabled = results.rows.item(0).Content;
                        if ((mobAdsEnabled == 3 && (deviceOS == 'android' || deviceOS == 'ios')) || (mobAdsEnabled == 1 && deviceOS == 'android') || (mobAdsEnabled == 2 && deviceOS == 'ios')) {

                            initAds();

                            if (type == 'Interstitial') {
                                AdMob.prepareInterstitial(
                                    {
                                        adId: admobidPro.interstitial,
                                        autoShow: true
                                    },
                                    function () {
                                    },
                                    function (e) {
                                        alert('prepareInterstitial Error: ' + JSON.stringify(e));
                                    });
                            } else if (type == 'Banner') {
                                AdMob.createBanner(
                                    {
                                        adId: admobidPro.banner,
                                        position: AdMob.AD_POSITION.BOTTOM_CENTER,
                                        autoShow: true
                                    },
                                    function () {
                                        bannerActive = true;
                                    },
                                    function (e) { alert('createBanner Error: ' + JSON.stringify(e)) });
                            }
                        }
                    }
                });
        });
    }

}

function ClearCallStack() {
    callStack = "";
}

function RemoveTemplate(templateID) {
    confirmBox(
        translate("brisati-predlozak"),
        translate("upozorenje"),
        translate("siguran-sam"),
        translate("odustani"),
        templateID,
        RemoveTemplateCallback
    );
}

function RemoveTemplateCallback(templateID) {
    db.transaction(function (tx) {
        tx.executeSql(
            "DELETE FROM Template WHERE TemplateID = " + templateID,
            [],
            function (tx, results) {
                console.log("Template deleted.");
            }
        );
    });

    ShowTemplates();
}

function ShowAddVehicleForm() {
    $(".listvehicle").hide();
    $(".addvehicle").show();
    $(".newvehicle").hide();
    $(".savevehicle").show();
}

function ShowVehiclesForm() {
    $("#txtNazivVozila").val("");
    $("#txtRegistracija").val("");

    $(".listvehicle").show();
    $(".addvehicle").hide();
    $(".newvehicle").show();
    $(".savevehicle").hide();
}

function AddVehicleToDatabase(name, plateNumber, sanitizedPlateNumber) {
    sanitizedPlateNumber = sanitizedPlateNumber.toUpperCase();
    db.transaction(function (tx) {
        tx.executeSql(
            'INSERT INTO Vehicle (Name, PlateNumber, CurrentSelected) VALUES ("' +
            name.replace(/\"/g, "'") +
            '","' +
            sanitizedPlateNumber +
            '", "true")',
            [],
            function () {
                if (sanitizedPlateNumber != plateNumber) {
                    alertBox(
                        translate("sanirana-reg") + sanitizedPlateNumber,
                        null,
                        translate("upozorenje"),
                        translate("ok")
                    );
                }
            }
        );
    });
}

// dodaje podatke o novom vozilu u bazu
function AddVehicle(IsWizzard) {
    var name = $("#txtNazivVozila").val();
    var plateNumber = $("#txtRegistracija").val();
    var sanitizedPlateNumber = SanitizePlateNumber(plateNumber);

    if (name != "" && plateNumber != "") {
        if (ValidatePlateNumber(sanitizedPlateNumber) == true) {
            if (IsWizzard) {
                db.transaction(function (tx) {
                    tx.executeSql(
                        "DELETE FROM Vehicle",
                        [],
                        function () {
                            $.ajax({
                                url: serviceURL + "/api/MobileApi/DeleteExistingCards",
                                type: "POST",
                                data: { userDeviceID: userDeviceID },
                                success: function (results) {
                                    AddVehicleToDatabase(name, plateNumber, sanitizedPlateNumber);
                                    RenderView("addcardwizard.html", "addvehiclewizard.html");
                                },
                                error: ajaxError,
                                timeout: timeout
                            });
                        },
                        null
                    );
                });
            } else {
                sanitizedPlateNumber = sanitizedPlateNumber.toUpperCase();
                db.transaction(function (tx) {
                    tx.executeSql(
                        "UPDATE Vehicle SET CurrentSelected = 'false'",
                        [],
                        function () {
                            tx.executeSql(
                                'INSERT INTO Vehicle (Name, PlateNumber, CurrentSelected) VALUES ("' +
                                name.replace(/\"/g, "'") +
                                '","' +
                                sanitizedPlateNumber +
                                '", "true")',
                                [],
                                function () {
                                    alertBox(
                                        translate("sanirana-reg") + sanitizedPlateNumber,
                                        null,
                                        translate("upozorenje"),
                                        translate("ok")
                                    );
                                }
                            );

                            if (callStack.indexOf("newpayment.html") > 0) {
                                Back(false);
                            } else {
                                ShowVehiclesForm();
                                FillVehicles();
                            }
                        },
                        null
                    );
                });
            }
        } else {
            alertBox(
                translate("neispravna-reg"),
                null,
                translate("upozorenje"),
                translate("ok")
            );
        }
    } else {
        alertBox(
            translate("upisite-nazivi-reg-vozila"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
    }
}

// briše vozilo iz baze
function RemoveVehicle(VehicleID, querySuccess, errorCB) {
    confirmBox(
        translate("brisanje-vozila"),
        translate("upozorenje"),
        translate("siguran-sam"),
        translate("odustani"),
        VehicleID,
        RemoveVehicleCallback
    );
}

function RemoveVehicleCallback(VehicleID) {
    db.transaction(function (tx) {
        tx.executeSql(
            "DELETE FROM Vehicle WHERE VehicleID = " + VehicleID,
            [],
            function () {
                FillVehicles();
            },
            null
        );
        tx.executeSql("DELETE FROM Template WHERE VehicleID = " + VehicleID);
    });
}
// kod pokretanja aplikacije određuje na koju stranicu će usmjeriti korisnika
function RouteAppStart() {
    GetCvvRequired();
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                var len = results.rows.length;
                if (len > 0 && results.rows.item(0).IsLogin == "true") {
                    $("#settingsCancelClose").show();
                    $("#settingsOK").show();
                    $("#firstSettingsOK").hide();
                    gExistingUser = results.rows.item(0).Username;
                    UpdateInitialInfo();
                    GetTransactionFeeDetails();
                    var isWizardComplete = results.rows.item(0).IsWizardComplete;
                    if (isWizardComplete == "true") {
                        RenderView("home.html", "");
                        IsPushNotificationIsEnabled();
                    } else {
                        RenderView("addvehiclewizard.html", "");
                    }

                    UpdateNotificationRegIDOnServer();
                } else {
                    RenderView("login.html", "");
                    HideLoading();
                }
            },
            null
        );
    });
}

// prikazuje predloške
function ShowTemplates() {
    $("#templates").empty();

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT Vehicle.PlateNumber AS VEHICLE, City.Name AS CITY, Zone.Name AS ZONE, " +
            "ZoneTariff.Description AS DESCRIPTION, Template.TemplateID AS TEMPLATEID, Template.Quantity AS QUANTITY FROM Template INNER JOIN Vehicle ON " +
            "Template.VehicleID = Vehicle.VehicleID INNER JOIN City ON Template.CityID = City.CityID " +
            "INNER JOIN Zone ON Template.ZoneID = Zone.ZoneID " +
            "INNER JOIN ZoneTariff ON Template.ZoneTariffID = ZoneTariff.ZoneTariffID",
            [],
            function (tx, results) {
                var $noResults = $(".noResults");

                if (results.rows.length > 0) {
                    $noResults.css("display", "none");

                    for (i = 0; i < results.rows.length; i++) {
                        var qDesc = "";
                        if (results.rows.item(i).QUANTITY > 1) {
                            qDesc = " (x" + results.rows.item(i).QUANTITY + ")";
                        }
                        $("#templates").append(
                            '<table class="templateTable">' +
                            '<tr class="templateRowInfo">' +
                            '<td class="templateItem">' +
                            '<img class="rowIcon" src="Images/Car.png" />' +
                            "</td>" +
                            "<td>" +
                            results.rows.item(i).VEHICLE +
                            "</td>" +
                            '<td class="templateItem">' +
                            '<img class="rowIcon" src="Images/City.png" />' +
                            "</td>" +
                            "<td>" +
                            results.rows.item(i).CITY +
                            "</td>" +
                            "</tr>" +
                            '<tr class="templateRowInfo">' +
                            '<td class="templateItem">' +
                            '<img class="rowIcon" src="Images/ParkZone.png" />' +
                            "</td>" +
                            "<td>" +
                            results.rows.item(i).ZONE +
                            "</td>" +
                            '<td class="templateItem">' +
                            '<img class="rowIcon" src="Images/StopWatch.png" />' +
                            "</td>" +
                            "<td>" +
                            results.rows.item(i).DESCRIPTION +
                            qDesc +
                            "</td>" +
                            "</tr>" +
                            "<tr >" +
                            '<td colspan="2" class="templateTableButton obrisiT" onclick="RemoveTemplate(' +
                            results.rows.item(i).TEMPLATEID +
                            ", " +
                            0 +
                            ')">' +
                            '<img src="Images/Delete.png" class="templateItem" /><br/>' +
                            translate("obrisi") +
                            "</td>" +
                            '<td colspan="2" class="templateTableButton plati-parkiranjeT" onclick="TemplateCheckPayment(' +
                            results.rows.item(i).TEMPLATEID +
                            ')">' +
                            '<img src="Images/Submit.png" class="templateItem" /><br/>' +
                            translate("plati-parkiranje") +
                            "</td>" +
                            "</tr>" +
                            "</table>"
                        );
                    }
                } else {
                    var toMove = Math.floor(screenHeight / 2.4);
                    $noResults.css("margin-top", toMove + "px");
                    $noResults.css("display", "block");
                }
            },
            null
        );
    });
}

// puni drop down listu s tipovima kartica
function FillCardTypeSelectList() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM CardType",
            [],
            function (tx, results) {
                $ddlTipoviKartica = $("#ddlTipoviKartica");

                $ddlTipoviKartica.find("option").remove();

                for (i = 0; i < results.rows.length; i++) {
                    var cardTypeName = results.rows.item(i).CardTypeName;
                    var cardTypeID = results.rows.item(i).CardTypeID;
                    $ddlTipoviKartica
                        .find("option")
                        .end()
                        .append(
                            "<option class='myoptionclass' value='" +
                            cardTypeID +
                            "'>" +
                            cardTypeName +
                            "</option>"
                        );
                }

                $ddlTipoviKartica.each(function (sorter, elm) {
                    var listitems = $(this)
                        .children("option.myoptionclass")
                        .get();
                    listitems.sort(function (a, b) {
                        var compA = $(a)
                            .text()
                            .toUpperCase();
                        var compB = $(b)
                            .text()
                            .toUpperCase();
                        compA = parseInt(compA, 10) || compA;
                        compB = parseInt(compB, 10) || compB;
                        return compA < compB ? -1 : compA > compB ? 1 : 0;
                    });
                    $.each(listitems, function (idx, itm) {
                        $($ddlTipoviKartica).append(itm);
                    });
                });

                // nakon što je popunjen select, gledam prvi option i sukladno postupam

                var selected_val = $ddlTipoviKartica.children("option:selected").val();
                if (selected_val != 6) {
                    $("#divBrojKartice").show();
                    $("#divBrojRacuna").hide();

                    $("#divMjesecGodina").show();
                    $("#divAVC").hide();

                    $("#divIstekKarticeObavijest").show();

                } else {
                    // ako je Smart City
                    $("#divBrojKartice").hide();
                    $("#divBrojRacuna").show();

                    $("#divMjesecGodina").hide();
                    $("#divAVC").show();

                    $("#divIstekKarticeObavijest").hide();
                }

                // dodan on change event handler
                $ddlTipoviKartica.on('change', function () {

                    if (this.value != 6) {
                        $("#divBrojKartice").show();
                        $("#divBrojRacuna").hide();

                        $("#divMjesecGodina").show();
                        $("#divAVC").hide();

                        $("#divIstekKarticeObavijest").show();
                    } else {
                        // ako je Smart City
                        $("#divBrojKartice").hide();
                        $("#divBrojRacuna").show();

                        $("#divMjesecGodina").hide();
                        $("#divAVC").show();

                        $("#divIstekKarticeObavijest").hide();
                    }
                });
            },
            null
        );
    });
}

// puni drop down listu s vozilima
function FillVehicleSelectList() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Vehicle",
            [],
            function (tx, results) {
                $("#ddlVozila")
                    .find("option")
                    .remove();

                for (i = 0; i < results.rows.length; i++) {
                    var vehicleID = results.rows.item(i).VehicleID;
                    var plateNumber = results.rows.item(i).PlateNumber;
                    var currentSelected = results.rows.item(i).CurrentSelected;
                    var vehicleName = results.rows.item(i).Name;

                    $("#ddlVozila")
                        .find("option")
                        .end()
                        .append(
                            "<option value='" +
                            vehicleID +
                            "'>" +
                            plateNumber +
                            " (" +
                            vehicleName +
                            ")</option>"
                        );

                    if (currentSelected == "true") {
                        $("#ddlVozila").val(vehicleID);
                    }
                }

                OnVehicleChange();
            },
            null
        );
    });
}

// prikazuje listu vozila iz baze
function FillVehicles() {
    $("#templates").empty();

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Vehicle",
            [],
            function (tx, results) {
                for (i = 0; i < results.rows.length; i++) {
                    var vehicleID = results.rows.item(i).VehicleID;
                    var plateNumber = results.rows.item(i).PlateNumber;
                    var name = results.rows.item(i).Name;

                    $("#templates").append(
                        "<table class='carTable historyItem'><tbody><tr><td class='templateItem'><img src='Images/Car.png' class='rowIcon'></td><td class='templateItemData'>" +
                        plateNumber +
                        " <br/> " +
                        name +
                        "</td><td class='templateTableButton templateItemButton' onclick='RemoveVehicle(" +
                        vehicleID +
                        ",  null, null)'><img src='Images/Delete_large.png' class='templateItem'></td></tr></tbody></table>"
                    );
                }
            },
            null
        );
    });
}

// puni drop down listu gradova
function FillGradoviSelectList() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM LastSelect",
            [],
            function (tx, results) {
                var lastSelect = 0;

                if (results.rows.length > 0) {
                    lastSelect = results.rows.item(0).CityID;
                }

                tx.executeSql(
                    "SELECT * FROM City ORDER BY Ordering",
                    [],
                    function (tx, results) {
                        $("#ddlGradovi")
                            .find("option")
                            .remove();

                        $("#ddlGradovi")
                            .find("option")
                            .end()
                            .append("<option value='" + 0 + "'>" + translate('odaberite-grad') + "</option>");

                        for (i = 0; i < results.rows.length; i++) {
                            var cityID = results.rows.item(i).CityID;
                            var name = results.rows.item(i).Name;
                            $("#ddlGradovi")
                                .find("option")
                                .end()
                                .append("<option value='" + cityID + "'>" + name + "</option>");

                            if (cityID == lastSelect) {
                                $("#ddlGradovi").val(cityID);
                            }
                        }

                        if (locatedCityID != 0) {
                            $("#ddlGradovi").val(locatedCityID.toString());
                            locatedCityID = 0;
                        }
                    },
                    null
                );
            },
            null
        );
    });
}

// puni drop down listu zona
function FillZoneSelectList() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM LastSelect",
            [],
            function (tx, results) {
                var lastSelect = 0;

                if (results.rows.length > 0) {
                    lastSelect = results.rows.item(0).ZoneID;
                }

                tx.executeSql(
                    "SELECT * FROM Zone WHERE CityID = '" + $("#ddlGradovi").val() + "'",
                    [],
                    function (tx, results) {
                        $("#ddlZone")
                            .find("option")
                            .remove();

                        for (i = 0; i < results.rows.length; i++) {
                            var zoneID = results.rows.item(i).ZoneID;
                            var name = results.rows.item(i).Name;
                            // var color = results.rows.item(i).Color;
                            $("#ddlZone")
                                .find("option")
                                .end()
                                .append("<option value='" + zoneID + "'>" + name + "</option>");

                            if (zoneID == lastSelect) {
                                $("#ddlZone").val(zoneID);
                            }
                        }

                        SetZoneColor();

                        CheckCardCompatibility($("#ddlGradovi").val(), false, null);
                    },
                    null
                );
            },
            null
        );
    });
}

function SetZoneColor() {
    db.transaction(function (tx) {
        var zoneID = $("#ddlZone").val();
        tx.executeSql(
            "SELECT * FROM Zone WHERE ZoneID=" + zoneID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var color = results.rows.item(0).Color;

                    if (color != "null") $("#zoneColor").css("background-color", color);
                    else $("#zoneColor").css("background-color", "whitesmoke");
                }
            },
            null
        );
    });
}

// puni drop down listu tarifa
function FillPeriodList() {
    var quantity = 1;
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM LastSelect",
            [],
            function (tx, results) {
                var lastSelect = 0;

                if (results.rows.length > 0) {
                    lastSelect = results.rows.item(0).ZoneTariffID;
                    quantity = results.rows.item(0).Quantity;
                }

                tx.executeSql(
                    "SELECT * FROM ZoneTariff WHERE ZoneID = " +
                    $("#ddlZone").val() +
                    " ORDER BY Ordinal",
                    [],
                    function (tx, results) {
                        $("#ddlTarife")
                            .find("option")
                            .remove();

                        for (i = 0; i < results.rows.length; i++) {
                            var row = results.rows.item(i);
                            var zoneTariffID = row.ZoneTariffID;
                            $("#ddlTarife")
                                .find("option")
                                .end()
                                .append(
                                    "<option value='" +
                                    zoneTariffID +
                                    "'>" +
                                    row.Description +
                                    "</option>"
                                );
                            if (zoneTariffID == lastSelect) {
                                $("#ddlTarife").val(zoneTariffID);
                            }
                        }
                        SetMinMaxValue(quantity);
                    },
                    null
                );
            },
            null
        );
    });
}

function GetDuration(minutes) {
    var rtrn = "";

    if (isNaN(minutes)) {
        rtrn = "-";
    } else {
        var hours = Math.floor(minutes / 60);
        var minutes = minutes % 60;

        if (minutes > 0) {
            rtrn = hours + "h " + minutes + "min";
        } else {
            rtrn = hours + "h";
        }
    }

    return rtrn;
}

function LoadTransactions() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    //ovo služi isključivo za debuggiranje, da dobijemo listu plaćanja za stvarni Hrvojev device 777, a ne za browser koji je na UserDeviceID = 1838
                    if (guid == '414d7172-36e3-497e-b4bd-8a6d72343384') {
                        guid = '2bb8837b-ae72-4a6a-bb9b-e0c2985c48d7';
                    }

                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/GetTransactions",
                        type: "POST",
                        data: { guid: guid },
                        success: function (results) {
                            if (results.Status == 1) {
                                $("#historyHolder").empty();

                                var transactions = results.Transactions;

                                var $noPayments = $(".noResults");

                                if (transactions.length > 0) {
                                    $noPayments.css("dispaly", "none");

                                    for (i = 0; i < transactions.length; i++) {
                                        var amount = transactions[i].Amount;
                                        var end = transactions[i].End;
                                        var shortEnd = transactions[i].ShortEnd;
                                        var start = transactions[i].Start;
                                        var delta =
                                            ConvertDateTimeToJavaScriptDate(end) -
                                            ConvertDateTimeToJavaScriptDate(start);
                                        var minutes = Math.round(delta / 1000 / 60);
                                        var status = parseInt(transactions[i].Status);
                                        var ticket = transactions[i].Ticket;
                                        var zone = transactions[i].Zone;
                                        var transactionID = transactions[i].TransactionID;
                                        var city = transactions[i].City;
                                        var secondsLeft = transactions[i].SecondsLeft;
                                        var zoneTariffPrice = transactions[i].ZoneTariffPrice;
                                        var cardTypeID = transactions[i].CardTypeID;

                                        var cardImg = "CreditCard";

                                        switch (cardTypeID) {
                                            case 1:
                                                cardImg = "AMEX";
                                                break;
                                            case 2:
                                                cardImg = "VISA";
                                                break;
                                            case 3:
                                                cardImg = "MasterCard";
                                                break;
                                            case 4:
                                                cardImg = "Diners";
                                                break;
                                            case 5:
                                                cardImg = "Maestro";
                                                break;
                                            case 6:
                                                cardImg = "ZINX";
                                                break;
                                        }

                                        var str = "";

                                        if (status == 400) {
                                            statusIcon = "statusGreen";

                                            str =
                                                '<div class="transactionsRow" onclick=ShowTransactionDetails("' +
                                                transactionID +
                                                '")><div class="statusLabel ' +
                                                statusIcon +
                                                '"></div><div class="cityZoneCell"><div>' +
                                                city +
                                                "</div><div>" +
                                                zone +
                                                '</div></div><div class="timeCell">' +
                                                GetDuration(minutes) +
                                                '</div><div class="dateTimeCell">' +
                                                shortEnd +
                                                '</div><div class="transactionCardCell"><img src="Images/' +
                                                cardImg +
                                                '.gif" /></div><div class="emptyCell"></div></div>';

                                            //str = "<div class='historyItem' onclick=ShowTransactionDetails('" + transactionID + "')><div class='status " + statusIcon + "'>&nbsp;</div><div class='dataHolder'><div class='data'><div class='zone'>" + city + "<br />" + zone + "</div><div class='duration'>" + GetDuration(minutes) +
                                            //      "</div><div class='expiration'><div class='time'><div class='floatRight'>" + end + "</div><div class='floatRight'><img src='Images/Alarm.png' class='timetime'/></div></div></div></div></div></div>";
                                        }

                                        if (status < 400) {
                                            statusIcon = "statusYellow";

                                            str =
                                                '<div class="transactionsRow" onclick=ShowTransactionDetails("' +
                                                transactionID +
                                                '")><div class="statusLabel ' +
                                                statusIcon +
                                                '"></div><div class="cityZoneCell"><div>' +
                                                city +
                                                "</div><div>" +
                                                zone +
                                                '</div></div><div class="timeCell">' +
                                                GetDuration(minutes) +
                                                '</div><div class="dateTimeCell">' +
                                                translate("u-obradi") +
                                                '</div><div class="transactionCardCell"><img src="Images/' +
                                                cardImg +
                                                '.gif" /></div><div class="emptyCell"></div></div>';

                                            //str = "<div class='historyItem' onclick=ShowTransactionDetails('" + transactionID + "')><div class='status " + statusIcon + "'>&nbsp;</div><div class='dataHolder'><div class='data'><div class='zone'>" + city + "<br />" + zone + "</div><div class='duration'>" + GetDuration(minutes) +
                                            //      "</div><div class='expiration'><div class='time'>u obradi</div></div></div></div></div>";
                                        }

                                        if (status > 400) {
                                            statusIcon = "statusRed";

                                            str =
                                                '<div class="transactionsRow" onclick=ShowTransactionDetails("' +
                                                transactionID +
                                                '")><div class="statusLabel ' +
                                                statusIcon +
                                                '"></div><div class="cityZoneCell"><div>' +
                                                city +
                                                "</div><div>" +
                                                zone +
                                                '</div></div><div class="timeCell">' +
                                                GetDuration(minutes) +
                                                '</div><div class="dateTimeCell">' +
                                                translate("odbijeno") +
                                                '</div><div class="transactionCardCell"><img src="Images/' +
                                                cardImg +
                                                '.gif" /></div><div class="emptyCell"></div></div>';

                                            //str = "<div class='historyItem' onclick=ShowTransactionDetails('" + transactionID + "')><div class='status " + statusIcon + "'>&nbsp;</div><div class='dataHolder'><div class='data'><div class='zone'>" + city + "<br />" + zone + "</div><div class='duration'>" + GetDuration(minutes) +
                                            //      "</div><div class='expiration'><div class='time'>neuspješna naplata</div></div></div></div></div>";
                                        }

                                        $("#historyHolder").append(str);
                                    }
                                } else {
                                    var toMove = Math.floor(screenHeight / 2.4);
                                    $noPayments.css("margin-top", toMove + "px");
                                    $noPayments.css("display", "block");
                                }
                            } else {
                                alertBox(
                                    translate("korisnicki-racun-je-deaktiviran"),
                                    null,
                                    translate("obavijest"),
                                    translate("ok")
                                );
                                logout();
                            }

                            HideLoading();
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });
}

function LoadNotifications() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;

                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/GetNotifications",
                        type: "POST",
                        data: { guid: guid },
                        success: function (results) {
                            if (results.Status == 1) {
                                $("#historyHolderNotif").empty();

                                var notifications = results.Notifications;

                                var $noPayments = $(".noResults");

                                if (notifications.length > 0) {
                                    $noPayments.css("dispaly", "none");

                                    for (i = 0; i < notifications.length; i++) {
                                        var notificationID = notifications[i].NotificationID;
                                        var status = parseInt(notifications[i].Status);
                                        var message = notifications[i].Message;
                                        var transactionID = notifications[i].TransactionID;
                                        var modified = notifications[i].Modified;
                                        var timetoprocess = notifications[i].TimeToProcess;
                                        var multicastid = notifications[i].MulticastID;
                                        var sendstatus =
                                            parseInt(notifications[i].SendStatus) == 1
                                                ? translate("poslano")
                                                : translate("nije-poslano");
                                        var messageid = notifications[i].MessageID;

                                        statusIcon = "statusGreen";

                                        str =
                                            '<div class="transactionsRow" style="cursor:pointer;" onClick="ShowNotification(' +
                                            notificationID +
                                            ')">' +
                                            //'<div class="transactionsRow" style="cursor:pointer;" onClick="GetDictionary(dictionary)">' +
                                            '<div class="notifdateTimeCell">' +
                                            modified +
                                            "</div>" +
                                            '<div id="Notif' +
                                            notificationID +
                                            '" class="notifMessageCell">' +
                                            message +
                                            "</div></div>";

                                        $("#historyHolderNotif").append(str);
                                    }
                                } else {
                                    var toMove = Math.floor(screenHeight / 2.4);
                                    $noPayments.css("margin-top", toMove + "px");
                                    $noPayments.css("display", "block");
                                }
                            } else {
                                alertBox(
                                    translate("greska-notifikacije"),
                                    null,
                                    translate("obavijest"),
                                    translate("ok")
                                );
                                logout();
                            }

                            HideLoading();
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });
}

function ConvertDateTimeToJavaScriptDate(dateTime) {
    var convertedDate = dateTime
        .replace(".", " ")
        .replace(".", " ")
        .replace(":", " ");
    var splittedDate = convertedDate.split(" ");
    return new Date(
        splittedDate[2],
        splittedDate[1],
        splittedDate[0],
        splittedDate[3],
        splittedDate[4]
    );
}

function LoadTransaction(transactionID) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;

                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/GetTransaction",
                        type: "POST",
                        data: { guid: guid, id: transactionID },
                        success: function (results) {
                            if (results.Status == 1) {
                                var status = results.Transactions[0].Status;

                                var start =
                                    "<div class='vrijeme'>" +
                                    results.Transactions[0].Start.split(" ")[1] +
                                    "</div><div class='dan'>" +
                                    results.Transactions[0].Start.split(" ")[0] +
                                    "</div>";
                                var end =
                                    "<div class='vrijeme'>" +
                                    results.Transactions[0].End.split(" ")[1] +
                                    "</div><div class='dan'>" +
                                    results.Transactions[0].End.split(" ")[0] +
                                    "</div>";

                                var ticket = results.Transactions[0].Ticket;
                                var city = results.Transactions[0].City;
                                var zone = results.Transactions[0].Zone;
                                var zoneId = results.Transactions[0].ZoneID;
                                var complaintNumber =
                                    results.Transactions[0].ComplaintNumber != ""
                                        ? results.Transactions[0].ComplaintNumber
                                        : "-";
                                var cardType = results.Transactions[0].CardType;
                                var amount =
                                    parseFloat(results.Transactions[0].Amount / 100).toFixed(2) +
                                    " " +
                                    results.Transactions[0].ZoneTariffCurrency;

                                $("#statusLine").removeClass();

                                if (status == 400) {
                                    status = translate("placeno");
                                    $("#statusLine").addClass("statusGreen");
                                }

                                if (status < 400) {
                                    status = translate("u-obradi");
                                    $("#statusLine").addClass("statusYellow");
                                    end = "-";
                                }

                                if (status > 400) {
                                    status = translate("neuspjesna-naplata");
                                    $("#statusLine").addClass("statusRed");
                                    end = "-";
                                }

                                $("#iznos").empty();
                                $("#iznos").append(amount);
                                $("#tipKartice").empty();
                                $("#tipKartice").append(cardType);
                                $("#grad").empty();
                                $("#grad").append(city);
                                $("#pocetak").empty();
                                $("#pocetak").append(start.toLocaleString());
                                $("#kraj").empty();
                                $("#kraj").append(end.toLocaleString());
                                $("#brojReklamacije").empty();
                                $("#brojReklamacije").append(complaintNumber);
                                $("#iznos").empty();
                                $("#iznos").append(amount);
                                $("#status").empty();
                                $("#status").append(status);
                                $("#registracija").empty();
                                $("#registracija").append(ticket);
                                $("#zona").empty();
                                $("#zona").append(zone);

                                $(".zoneInfo").click(function () {
                                    GetZoneInfo(zoneId);
                                });
                            } else {
                                switch (results.Code) {
                                    case -1:
                                    case -2:
                                        alertBox(
                                            translate("transakcija-nije-pronađena"),
                                            null,
                                            translate("obavijest"),
                                            translate("ok")
                                        );
                                        break;
                                    case -3:
                                    case -4:
                                        alertBox(
                                            translate("korisnicki-racun-je-deaktiviran"),
                                            null,
                                            translate("obavijest"),
                                            translate("ok")
                                        );
                                        logout();
                                        break;
                                }
                            }

                            HideLoading();
                        },
                        error: ajaxError,
                        timeout: timeout
                    });
                }
            },
            null
        );
    });
}

function ShowTransactionDetails(transactionID) {
    selectedTransactionID = transactionID;
    RenderView("details.html", "history.html");
}

function fullScreenCheck() {
    if (document.fullscreenElement) return;
    return document.documentElement.requestFullscreen();
}

//function LockOrientation() {
//  if (deviceOS != "browser") {
//    try {
//      fullScreenCheck();
//    } catch (err) {
//      console.error(err);
//    }
//    var orientation = window.screen.orientation;
//    console.log(orientation.type);
//    screen.orientation.lock(orientation.type).catch(function(error) {
//      console.log(error);
//    });
//  }
//}

function ShowNotification(notificationID) {
    var message = $("#Notif" + notificationID).html();
    alertBox(message, showAdAfterAlert, translate("obavijest"), translate("ok"));
}

var attemptCounter = 0;
function GetDictionary() {
    console.log("GetDictionary started.");
    $.ajax({
        url: serviceURL + "/api/MobileApi/GetDictionary",
        type: "GET",
        success: function (dictionaryFromServer) {
            attemptCounter = 0;
            if (dictionaryFromServer != "") {
                console.log("Dictionary has gotten from server.")
                var data = JSON.parse(dictionaryFromServer);
                SetDictionary(data);
                InitializeApp();
            }
            else {
                console.log("No dictionary on server");
                ajaxError(null, "No dictionary on server.");
            }

        },
        error: ajaxError,
            
        //    function (xhr, textStatus, errorThrown) {
        //    if (attemptCounter < 4 && xhr && xhr.status === ) {
        //        GetDictionary(attemptCounter++);
        //    } else {
        //        ajaxError(xhr, "Repeated connection error (4 times).");
        //    }
        //},
            //ajaxError,
        timeout: timeout*2
    });
}

function SetCardValidationData(data) {
    creditCards = data;
}

function GetCardValidationData() {
    $.ajax({
        url: serviceURL + "/api/MobileApi/GetCardValidationData",
        type: "GET",
        success: function (cardValidationData) {
            if (cardValidationData) {
                var data = cardValidationData;
                SetCardValidationData(data);
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}

function ShowTransactionPrice(zoneTariffID, ctId, cityID, quantity) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM ZoneTariff WHERE ZoneTariffID = " + zoneTariffID,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var price = results.rows.item(0).Price;
                    price = price * quantity;
                    var currency = results.rows.item(0).Currency;
                    var floatPrice = parseFloat(price / 100);
                    CalculateAndShowTransFee(floatPrice, currency, ctId, cityID);
                }
            },
            null
        );
    });
}

function CalculateAndShowTransFee(price, currency, ctId, cityID) {
    fee = 0;
    var cardValidity = "";
    var cardMaskedNumber = "";
    var cardTypeName = "";

    db.transaction(function (tx) {
        //obzirom da u karticama može postojati samo jedna kartica ctID tipa, tražim po tome podatke o kartici
        tx.executeSql("SELECT * FROM Card WHERE CardTypeID = " + ctId, [], function (
            tx,
            results
        ) {
            if (results.rows.length > 0) {
                cardValidity = results.rows.item(0).ExpDate;
                cardMaskedNumber = results.rows.item(0).CardPreview;

            }
            tx.executeSql("SELECT * FROM City WHERE CityID = " + cityID, [], function (
                tx,
                results
            ) {
                if (results.rows.item(0).TransactionFeeEnabled != 0) {
                    tx.executeSql(
                        "SELECT * FROM CardType WHERE CardTypeID = " + ctId,
                        [],
                        function (tx, results) {
                            cardTypeName = results.rows.item(0).CardTypeName;
                            if (results.rows.item(0).TransactionFeeEnabled != 0) {
                                tx.executeSql(
                                    "SELECT * FROM TransactionFee",
                                    [],
                                    function (tx, results) {
                                        if (results.rows.length > 0) {
                                            for (i = 0; i < results.rows.length; i++) {
                                                var transFee = results.rows[i];
                                                if (
                                                    price <= transFee.AmountTo &&
                                                    price >= transFee.AmountFrom
                                                ) {
                                                    if (transFee.FeeCurrencyID == 191) {
                                                        fee = fee + transFee.FeeAmount;
                                                    } else {
                                                        fee = fee + price * transFee.FeeAmount;
                                                    }
                                                }
                                            }
                                        }
                                        $("#fee").append(
                                            translate("trans-naknada") +
                                            fee.toFixed(2) +
                                            translate("trans-naknada-after")
                                        );
                                        var priceWithFee = price + fee;
                                        $(".price").append(
                                            priceWithFee.toFixed(2) + " " + currency
                                        );
                                        $(".paymentCard").append(
                                            cardTypeName +
                                            "<br>(" +
                                            cardMaskedNumber + ((cardValidity != "null") ? ", " + cardValidity : "") +
                                            ")"
                                        );
                                        //tx.executeSql(
                                        //  "SELECT * FROM CardType WHERE CardTypeID = " + ctId,
                                        //  [],
                                        //  function (tx, results) {
                                        //      $(".paymentCard").append(results.rows.item(0).CardTypeName + " (" + cardMaskedNumber + ", " + cardValidity + ")");
                                        //  }
                                        //);
                                    },
                                    null
                                );
                            } else {
                                //nema naknade jer u za tu vrstu kartice nije inejblana (još)
                                var priceWithFee = price;
                                $(".price").append(priceWithFee.toFixed(2) + " " + currency);
                                $(".paymentCard").append(
                                    cardTypeName +
                                    "<br>(" +
                                    cardMaskedNumber + ((cardValidity != "null") ? ", " + cardValidity : "") +
                                    ")"
                                );
                                //tx.executeSql(
                                //  "SELECT * FROM CardType WHERE CardTypeID = " + ctId,
                                //  [],
                                //  function (tx, results) {
                                //      $(".paymentCard").append(results.rows.item(0).CardTypeName + " (" + cardMaskedNumber + ", " + cardValidity + ")");
                                //  }
                                //);
                            }
                        }
                    );
                } else {
                    //nema naknade jer u tom gradu nije inejblana (još)
                    var priceWithFee = price + fee;
                    $(".price").append(priceWithFee.toFixed(2) + " " + currency);
                    tx.executeSql(
                        "SELECT * FROM CardType WHERE CardTypeID = " + ctId,
                        [],
                        function (tx, results) {
                            cardTypeName = results.rows.item(0).CardTypeName;
                            $(".paymentCard").append(
                                cardTypeName +
                                "<br>(" +
                                cardMaskedNumber + ((cardValidity != "null") ? ", " + cardValidity : "") +
                                ")"
                            );
                        }
                    );
                }
            });
        });
    });
}

function LoadInitialInformationNew(refreshSourceTypeID) {

    if (deviceOS != 'browser') {
        let getOptions = {
            enableHighAccuracy: true, timeout: 1000
        };

        navigator.geolocation.getCurrentPosition(function (position) {
            latitude = position.coords.latitude;
            longitude = position.coords.longitude;
        }, null, getOptions);
    }

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM User",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var guid = results.rows.item(0).GUID;
                    ShowLoading();
                    $.ajax({
                        url: serviceURL + "/api/MobileApi/InitializeNew",
                        type: "POST",
                        data: { GUID: guid, Latitude: latitude, Longitude: longitude, RefreshSourceTypeID: refreshSourceTypeID, IsAccountSupported: true, NotificationRegID: gnotifRegId },
                        success: function (results) {
                            if (results.Status == 1) {
                                db.transaction(function (tx) {
                                    tx.executeSql("DROP TABLE City", [], function (tx) {
                                        tx.executeSql(
                                            "CREATE TABLE IF NOT EXISTS City (CityID INTEGER NOT NULL PRIMARY KEY, Name, Cards, TransactionFeeEnabled, Ordering)",
                                            [],
                                            function (tx) {
                                                for (i = 0; i < results.Cities.length; i++) {
                                                    var city = results.Cities[i];
                                                    if (city.IsLocated == true) {
                                                        locatedCityID = city.CityID;
                                                    }
                                                    tx.executeSql(
                                                        'INSERT INTO City (CityID, Name, Cards, TransactionFeeEnabled, Ordering) VALUES ("' +
                                                        city.CityID +
                                                        '","' +
                                                        city.Name.replace(/\"/g, "'") +
                                                        '","' +
                                                        city.Cards.replace(/\"/g, "'") +
                                                        '","' +
                                                        city.TransactionFeeEnabled +
                                                        '","' +
                                                        city.Ordering +
                                                        '")',
                                                        [],
                                                        null
                                                    );
                                                }
                                            }
                                        );
                                    });

                                    tx.executeSql(
                                        "DELETE FROM Zone",
                                        [],
                                        function (tx) {
                                            for (i = 0; i < results.Zones.length; i++) {
                                                var zone = results.Zones[i];
                                                tx.executeSql(
                                                    'INSERT INTO Zone (ZoneID, CityID, Name, Color, Contact) VALUES ("' +
                                                    zone.ZoneID +
                                                    '","' +
                                                    zone.CityID +
                                                    '","' +
                                                    zone.Name.replace(/\"/g, "'") +
                                                    '","' +
                                                    zone.Color.replace(/\"/g, "'") +
                                                    '","' +
                                                    zone.Contact.replace(/\"/g, "'") +
                                                    '")'
                                                );
                                            }
                                        },
                                        null
                                    );

                                    tx.executeSql("DROP TABLE ZoneTariff", [], function (tx) {
                                        tx.executeSql(
                                            "CREATE TABLE IF NOT EXISTS ZoneTariff (ZoneTariffID INTEGER NOT NULL PRIMARY KEY, ZoneID INTEGER, Description, Ordinal INTEGER, Price INTEGER, Currency, MaxQuantity INTEGER, DetailedClientDesc)",
                                            [],
                                            function (tx) {
                                                if (results.ZoneTariffs.length == 0) {
                                                    ShowRetryScreen(null);
                                                } else {
                                                    recursiveCounter = 0;
                                                    tariffs = results.ZoneTariffs;
                                                    RecursiveInsertIntoZoneTariff(tx);
                                                }
                                            }
                                        );
                                    });

                                    tx.executeSql("DROP TABLE CardType", [], function (tx) {
                                        tx.executeSql(
                                            "CREATE TABLE IF NOT EXISTS CardType (CardTypeID INTEGER NOT NULL PRIMARY KEY, CardTypeName, TransactionFeeEnabled INTEGER, Active INTEGER, BalanceEnabled INTEGER, IsAccount INTEGER, OrderBy INTEGER, CheckCardTypeName)",
                                            [],
                                            function (tx) {
                                                if (results.CardTypes.length == 0) {
                                                    ShowRetryScreen(null);
                                                } else {
                                                    for (i = 0; i < results.CardTypes.length; i++) {
                                                        var cardType = results.CardTypes[i];
                                                        tx.executeSql(
                                                            'INSERT INTO CardType (CardTypeID, CardTypeName, TransactionFeeEnabled, Active, BalanceEnabled, IsAccount, OrderBy, CheckCardTypeName) VALUES ("' +
                                                            cardType.CardTypeID +
                                                            '","' +
                                                            cardType.CardTypeName.replace(/\"/g, "'") +
                                                            '","' +
                                                            cardType.TransactionFeeEnabled +
                                                            '","' +
                                                            cardType.Active +
                                                            '","' +
                                                            cardType.BalanceEnabled +
                                                            '","' +
                                                            cardType.IsAccount +
                                                            '","' +
                                                            cardType.OrderBy +
                                                            '","' +
                                                            cardType.CheckCardTypeName +
                                                            '")'
                                                        );
                                                    }
                                                }
                                            }
                                        );
                                    });

                                    //if (results.BannerVisible === 1) {
                                    //    bannerVisible = true;
                                    //} else {
                                    //    bannerVisible = false;
                                    //};

                                    tx.executeSql(
                                        "DELETE FROM Dictionary",
                                        [],
                                        function (tx) {
                                            var bannerURL = results.BannerURL.replace(/\"/g, "'");

                                            tx.executeSql(
                                                'INSERT INTO Dictionary (KeyName, Content) VALUES ("Info","' +
                                                results.Info.replace(/\"/g, "'") +
                                                '")'
                                            );
                                            tx.executeSql(
                                                'INSERT INTO Dictionary (KeyName, Content) VALUES ("BannerURL","' +
                                                bannerURL +
                                                '")',
                                                [],
                                                function () {
                                                    if (CurrentView == "home.html") setHomeScreenLayout();
                                                }
                                            );
                                            tx.executeSql(
                                                'INSERT INTO Dictionary (KeyName, Content) VALUES ("BannerVisible",' +
                                                results.BannerVisible +
                                                ')', [], function (tx) { });
                                            tx.executeSql(
                                                'INSERT INTO Dictionary (KeyName, Content) VALUES ("BannerHref","' +
                                                results.BannerHref +
                                                '")', [], function (tx) { });
                                            tx.executeSql(
                                                'INSERT INTO Dictionary (KeyName, Content) VALUES ("MobAdsEnabled",' +
                                                results.MobAdsEnabled +
                                                ')', [], function (tx) { });

                                            tx.executeSql('SELECT LastInitialMessageID FROM LastUpdate',
                                                [],
                                                function (tx, result) {
                                                    var lastInitialMessageID = 0;
                                                    if (result.rows.length > 0) {
                                                        lastInitialMessageID = result.rows.item(0).LastInitialMessageID;
                                                    }
                                                    if (results.InitialMessage != "" && results.InitialMessageID != 0 && results.InitialMessageID > lastInitialMessageID) {
                                                        var splitter = "||";
                                                        if (results.InitialMessage.indexOf(splitter) == -1) {
                                                            if (refreshSourceTypeID != 3) {
                                                                alertBox(results.InitialMessage,
                                                                    showAdAfterAlert,
                                                                    translate("obavijest"),
                                                                    translate("ok")
                                                                );
                                                            } else {
                                                                //ne pokazujemo oglas nakon alerta, ako se radi o inicijalizaciji zbog logina
                                                                alertBox(results.InitialMessage,
                                                                    null,
                                                                    translate("obavijest"),
                                                                    translate("ok")
                                                                );
                                                            }
                                                        } else {
                                                            //više je poruka
                                                            var messages = results.InitialMessage.split(splitter);
                                                            for (var i = 0, len = messages.length; i < len; i++) {
                                                                if (i != 0) {
                                                                    //nije prva poruka, samo šibaj
                                                                    alertBox(messages[i],
                                                                        null,
                                                                        translate("obavijest"),
                                                                        translate("ok")
                                                                    );
                                                                } else {
                                                                    //prva poruka u nizu => prikazat će se kao zadnja, pa na njen dismis treba postaviti oglas, ako uopće treba...
                                                                    if (refreshSourceTypeID != 3) {
                                                                        alertBox(messages[i],
                                                                            showAdAfterAlert,
                                                                            translate("obavijest"),
                                                                            translate("ok")
                                                                        );
                                                                    } else {
                                                                        //ne pokazujemo oglas nakon alerta, ako se radi o inicijalizaciji zbog logina
                                                                        alertBox(messages[i],
                                                                            null,
                                                                            translate("obavijest"),
                                                                            translate("ok")
                                                                        );
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        tx.executeSql('UPDATE LastUpdate SET LastInitialMessageID = ' + results.InitialMessageID);
                                                    } else {
                                                        //ne pokazujemo oglas nakon alerta, ako se radi o inicijalizaciji zbog logina
                                                        if (refreshSourceTypeID != 3) {
                                                            //displayAd('Interstitial');
                                                        }
                                                    };
                                                });
                                        },
                                        null
                                    );
                                });
                            } else {
                                // korisnik je daktiviran, potrebno je ga odlogirati...
                                alertBox(
                                    translate("korisnicki-racun-je-deaktiviran"),
                                    null,
                                    translate("obavijest"),
                                    translate("ok")
                                );
                                logout();
                            }

                            HideLoading();
                        },
                        error: ajaxError,
                        timeout: timeout*2
                    });
                }
            },
            null
        );
    });
}

function FillPeriodListIfNewPayment() {
    if (CurrentView == "newpayment.html") {
        FillPeriodList();
    }
}

var recursiveCounter = 0;
var tariffs;

function RecursiveInsertIntoZoneTariff(tx) {
    if (recursiveCounter < tariffs.length) {
        var zoneTariff = tariffs[recursiveCounter];
        tx.executeSql(
            'INSERT INTO ZoneTariff (ZoneTariffID, ZoneID, Description, Ordinal, Price, Currency, MaxQuantity, DetailedClientDesc) VALUES ("' +
            zoneTariff.ZoneTariffID +
            '","' +
            zoneTariff.ZoneID +
            '","' +
            zoneTariff.Description.replace(/\"/g, "'") +
            '","' +
            zoneTariff.Order +
            '","' +
            zoneTariff.Price +
            '","' +
            zoneTariff.Currency +
            '","' +
            zoneTariff.MaxQuantity +
            '","' +
            zoneTariff.DetailedClientDesc +
            '")',
            [],
            function (tx) {
                recursiveCounter++;
                RecursiveInsertIntoZoneTariff(tx);
            }
        );
    }
    else {
        //ovdje je kraj
        FillPeriodListIfNewPayment();
    };
};

function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

function ResetPassword() {
    var email = $("#txtEmail")
        .val()
        .trim();
    var password = $("#txtNovaLozinka").val();
    var passwordRepeated = $("#txtPonovljenaLozinka").val();

    if (email == "" || password == "" || passwordRepeated == "") {
        alertBox(
            translate("upisite-sve-podatke"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (password != passwordRepeated) {
        alertBox(
            translate("zaporke-se-ne-podudaraju"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (password.length < 6) {
        alertBox(
            translate("minimalna-duljina"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (validateEmail(email) === false) {
        alertBox(
            translate("neispravan-email"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    var jezikId = 1;

    if (langId) {
        jezikId = langId;
    }

    navigator.notification.confirm(
        translate("resetirati-lozinku"),
        function (buttonIndex) {
            if (buttonIndex == 2) {
                ShowLoading();

                $.ajax({
                    url: serviceURL + "/api/MobileApi/ResetPassword",
                    type: "POST",
                    data: { Password: password, Email: email, LanguageID: jezikId },
                    success: function (results) {
                        if (results.Status == 1) {
                            RenderView("login.html", "");
                            alertBox(
                                translate("reset-lozinke"),
                                null,
                                translate("resetiranje-lozinke"),
                                translate("ok")
                            );
                        } else {
                            alertBox(
                                translate("neuspjesno-resetiranje-lozinke") + results.Message,
                                null,
                                translate("upozorenje"),
                                translate("ok")
                            );
                        }

                        HideLoading();
                    },
                    error: ajaxError,
                    timeout: timeout
                });
            }
        },
        translate("upozorenje"),
        ["Odustani", "Siguran sam"]
    );
}

function RegisterGoToStep2() {
    var email = $("#txtEmail")
        .val()
        .trim();
    //var username = $("#txtKorisnickoIme").val();
    var username = email;
    var password = $("#txtLozinka").val();
    var passwordRepeated = $("#txtPonovljenaLozinka").val();

    if (
        email == "" ||
        username == "" ||
        password == "" ||
        passwordRepeated == ""
    ) {
        alertBox(
            translate("upisite-sve-podatke"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (password != passwordRepeated) {
        alertBox(
            translate("zaporke-se-ne-podudaraju"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (password.length < 6) {
        alertBox(
            translate("minimalna-duljina"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    if (validateEmail(email) === false) {
        alertBox(
            translate("neispravan-email"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    $(".registerStep1").hide();
    $(".continueRegistration").hide();
    $(".registerStep2").show();
    $("#txtState").val(state.toUpperCase());
    $(".confirmRegistration").show();
}

function Register() {
    var email = $("#txtEmail")
        .val()
        .trim();
    //var username = $("#txtKorisnickoIme").val();
    var username = email;
    var password = $("#txtLozinka").val();
    var passwordRepeated = $("#txtPonovljenaLozinka").val();
    var name = $("#txtName").val();
    var surname = $("#txtSurname").val();
    var address = $("#txtAddress").val();
    var zip = $("#txtZip").val();
    var city = $("#txtCity").val();
    var state = $("#txtState").val();
    var phone = $("#txtPhone").val();

    if (
        name == "" ||
        surname == "" ||
        address == "" ||
        zip == "" ||
        city == "" ||
        state == "" ||
        phone == ""
    ) {
        alertBox(
            translate("upisite-sve-podatke"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
        return;
    }

    ShowLoading();

    var operSustav = "android";
    var jezikId = 1;

    if (langId) {
        jezikId = langId;
    }
    if (deviceOS) {
        operSustav = deviceOS;
    }

    $.ajax({
        url: serviceURL + "/api/MobileApi/Register",
        type: "POST",
        data: {
            Username: username,
            Password: password,
            Email: email,
            DeviceOS: operSustav,
            NotificationRegID: "",
            LanguageID: jezikId,
            Name: name,
            Surname: surname,
            Address: address,
            Zip: zip,
            City: city,
            State: state,
            Phone: phone
        },
        success: function (results) {
            if (results.Status == 1) {
                RenderView("login.html", "");
                alertBox(
                    translate("uspjesna-registracija"),
                    null,
                    "Registracija",
                    translate("ok")
                );
            } else {
                alertBox(
                    translate("neuspjesna-registracija") + results.Message,
                    null,
                    translate("upozorenje"),
                    translate("ok")
                );
            }

            HideLoading();
        },
        error: ajaxError,
        timeout: timeout
    });
}
var gregIdValue = "";
var gExistingUser = "";

// inicijalna prijava u aplikaciju
function LogIn() {
    var username = $("#txtKorisnickoIme")
        .val()
        .trim();
    var password = $("#txtLozinka").val();

    var existingUser = "";
    var existingGUID = "";

    if (username == "" || password == "") {
        alertBox(
            translate("korisnicko-ime-i-password"),
            null,
            translate("upozorenje"),
            translate("ok")
        );
    } else {
        db.transaction(function (tx) {
            tx.executeSql(
                "SELECT * FROM RegID",
                [],
                function (tx, results) {
                    var regIdValue = "";

                    if (results.rows.length > 0) {
                        regIdValue = results.rows.item(0).Value;
                        gregIdValue = regIdValue;
                    }

                    tx.executeSql(
                        "SELECT * FROM User",
                        [],
                        function (tx, results) {
                            if (results.rows.length > 0) {
                                var existingUser = results.rows.item(0).Username;

                                if (username == existingUser) {
                                    LoginRequest(username, password, deviceOS, regIdValue, uuid);
                                } else {
                                    // postavljamo pitalicu korisniku da li se stvatrno želi ulogirati
                                    // te pobrisati sve postojeće postavke

                                    confirmBox(
                                        translate("brisanje-postavki") + " Novi upis: " + username + ", u bazi: " + existingUser,
                                        translate("upozorenje"),
                                        translate("da-prijavi-me"),
                                        translate("odustani"),
                                        null,
                                        PrijavaCallback
                                    );
                                }
                            } else {
                                // ulogirati korisnika
                                LoginRequest(username, password, deviceOS, regIdValue, uuid);
                            }
                        },
                        null
                    );
                },
                null
            );
        });
    }
}

function PrijavaCallback() {
    var username = $("#txtKorisnickoIme")
        .val()
        .trim();
    var password = $("#txtLozinka").val();
    clearDatabase();
    LoginRequest(username, password, deviceOS, gregIdValue, uuid);
}

function GetUserAgreement(langID) {
    ShowLoading();
    $.ajax({
        url: serviceURL + "/api/MobileApi/GetUserAgreement",
        type: "POST",
        data: { LanguageID: langID },
        success: function (result) {
            db.transaction(function (tx) {
                tx.executeSql(
                    "SELECT * FROM UserAgreement",
                    [],
                    function (tx, results) {
                        if (results.rows.length > 0) {
                            tx.executeSql(
                                'UPDATE UserAgreement SET Agreement = "' +
                                result.replace(/\"/g, "'") +
                                '"',
                                [],
                                function () {
                                    FirstShowUserAgreement();
                                },
                                null
                            );
                        } else {
                            tx.executeSql(
                                'INSERT INTO UserAgreement (Value, Agreement) VALUES ("","' +
                                result.replace(/\"/g, "'") +
                                '")',
                                [],
                                function () {
                                    FirstShowUserAgreement();
                                },
                                null
                            );
                        }
                        HideLoading();
                    },
                    null
                );
            });
        },
        error: ajaxError,
        timeout: timeout
    });
}

function FirstShowUserAgreement() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM UserAgreement",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var value = results.rows.item(0).Value;
                    var agreement = results.rows.item(0).Agreement;
                    if (value !== "agreed") {
                        $("#generalCondition").show();
                        $("#generalConditionAgreeButton").show();
                        $("#generalConditionCloseButton").hide();
                        $("#generalConditionContent").html(agreement);
                        $(".maincontainer").hide();
                    }
                    HideLoading();
                }
            },
            null
        );
    });
}

var loggedIn = false;

function LoginRequest(username, password, deviceOS, regIdValue, uuid) {
    ShowLoading();
    $.ajax({
        url: serviceURL + "/api/MobileApi/LogIn",
        type: "POST",
        data: {
            Username: username,
            Password: password,
            DeviceOS: deviceOS,
            NotificationRegID: regIdValue,
            UUID: uuid,
            LanguageID: langId
        },
        success: function (results) {
            if (results.Status == 1) {
                loggedIn = true;
                $("#settingsCancelClose").show();
                $("#settingsOK").show();
                $("#firstSettingsOK").hide();

                gExistingUser = username;
                userDeviceGuid = results.GUID;
                userDeviceID = results.UserDeviceID;
                langId = results.LanguageID;
                SetUser(username, results.GUID);
                LoadInitialInformationNew(3);
                UpdateNotificationRegIDOnServer();
                GetPermissionForiOSNotifications();
            } else {
                loggedIn = false;
                alertBox(results.Message, null, translate("upozorenje"), translate("ok"));
            }

            HideLoading();
        },
        error: ajaxError,
        timeout: timeout
    });
}

function UpdateNotificationRegIDOnServer() {
    //alertBox('UpdateNotificationRegIDOnServer');
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM RegID",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var notified = results.rows.item(0).ServerNotified;
                    var regIdValue = results.rows.item(0).Value;
                    gnotifRegId = regIdValue;
                    notifRegIdSent = (notified == "false") ? "not sent" : "sent";
                    if (notified == "false") {
                        db.transaction(function (tx) {
                            tx.executeSql(
                                "SELECT * FROM User",
                                [],
                                function (tx, results) {
                                    if (results.rows.length > 0) {
                                        var guid = results.rows.item(0).GUID;
                                        ShowLoading();
                                        $.ajax({
                                            url: serviceURL + "/api/MobileApi/UpdateRegID",
                                            type: "POST",
                                            data: { GUID: guid, NotificationRegID: regIdValue },
                                            success: function (result) {
                                                HideLoading();
                                                if (result.Status == 1) {
                                                    notifRegIdSent = "sent";
                                                    db.transaction(function (tx) {
                                                        tx.executeSql(
                                                            "UPDATE RegID SET ServerNotified = 'true'"
                                                        );
                                                    });
                                                }
                                            },
                                            error: ajaxError,
                                            timeout: timeout
                                        });
                                    }
                                },
                                null
                            );
                        });
                    }
                } else {
                    RegisterDevice();
                }
            },
            null
        );
    });
}

function ShowRetryScreen(message) {
    var $connectionErrorLabel = $("#connectionErrorLabel");
    $connectionErrorLabel.empty();
    $connectionErrorLabel.append("Connection error");
    if (message != null) {
        $connectionErrorLabel.append(" : " + message);
    }
    $connectionErrorLabel.css("display", "block");
    $("#connectionErrorButton").css("display", "block");
    $("i").css("display", "none");
    $("#loadingLabel").css("display", "none");

    var toMove = Math.floor(screenHeight / 3);
    $("#spinnerWrapper").css("margin-top", toMove);
    $("#overflow").show();
}

function HideRetryScreen() {
    $("#overflow").hide();
}

function ShowLoading() {
    $("#connectionErrorLabel").css("display", "none");
    $("#connectionErrorButton").css("display", "none");
    $("i").css("display", "inline-block");
    $("#loadingLabel").css("display", "block");

    var toMove = Math.floor(screenHeight / 2.4);
    $("#spinnerWrapper").css("margin-top", toMove);
    $("#overflow").show();
}

function HideLoading() {

    $("#overflow").hide();
}

function ajaxError(jqXHR, exception) {
    //HideLoading();

    if (jqXHR) {
        if (jqXHR.status === 0) {
            if (exception === "timeout") {
                if (attemptCounter < 3) {
                    var z = Number(attemptCounter) + Number(1);
                    $("#loadingLabel").text("...(" + z + ")...")
                    GetDictionary(attemptCounter++);
                } else {
                    attemptCounter = 0;
                    ShowRetryScreen("multiple retries failure");
                }
            } else {
                attemptCounter = 0;
                ShowRetryScreen("check network settings");
            }
        } else if (jqXHR.status == 404) {
            attemptCounter = 0;
            ShowRetryScreen("server currently not available.");
        } else if (jqXHR.status == 500) {
            attemptCounter = 0;
            ShowRetryScreen("server currently cannot process the request.");
        } else if (exception === "parsererror") {
            attemptCounter = 0;
            ShowRetryScreen(
                "server currently cannot process the request (ParserError)."
            );
        } else if (exception === "timeout") {
            attemptCounter = 0;
            ShowRetryScreen("request timed out.");
        } else if (exception === "abort") {
            attemptCounter = 0;
            ShowRetryScreen("request aborted.");
        } else {
            attemptCounter = 0;
            ShowRetryScreen(jqXHR.responseText);
        }
        jqXHR.abort();
    }
    else {
        ShowRetryScreen(exception);
    }

}

function crypt(data, key) {
    return CryptoJS.AES.encrypt(data, key).toString();
}

function decrypt(data, key) {
    try {
        return CryptoJS.AES.decrypt(data, key).toString(CryptoJS.enc.Utf8);
    } catch (err) {
        return false;
    }
}

function styleLozinka(pwdBox) {
    if (pwdBox.value != "") {
        $(pwdBox).addClass("pwdDiscs", 500);
    } else {
        $(pwdBox).removeClass("pwdDiscs", 500);
    }
}

function GetZoneInfo(zoneId) {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Zone WHERE ZoneID = " + zoneId,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var contact = results.rows.item(0).Contact;
                    alertBox(contact, null, "Koncesionar", translate("ok"));
                } else {
                    alertBox(
                        translate("ne-postoje-podaci-o-koncesionaru"),
                        null,
                        translate("koncesionar"),
                        translate("ok")
                    );
                }
            },
            null
        );
    });
}

function nospaces(t) {
    if (t.value.match(/\s/g)) {
        t.value = t.value.replace(/\s/g, "");
    }
}

function setUserAgreeWithGeneralConditions() {
    db.transaction(function (tx) {
        tx.executeSql("UPDATE UserAgreement SET Value = 'agreed'", [], function () {
            $(".maincontainer").show();
            $("#generalCondition").hide();
            updateLanguage();
        });
    });
}

function closeUserAgreement() {
    $(".maincontainer").show();
    $("#generalCondition").hide();
}

function showUserAgreement() {
    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM UserAgreement",
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    var agreement = results.rows.item(0).Agreement;
                    $("#generalConditionContent").html(agreement);
                    $("#generalConditionAgreeButton").hide();
                    $("#generalConditionCloseButton").show();

                    $("#generalConditionCloseButton").attr(
                        "placeholder",
                        translate("zatvori")
                    );
                    $("#generalConditionAgreeButton").attr(
                        "placeholder",
                        translate("slazem-se")
                    );

                    $("#generalCondition").show();
                }
            },
            null
        );
    });
}

function settingsCancelClose() {
    $(".maincontainer").show();
    $("#settings").hide();
}

function showSettings() {
    $("#settingsOK").show();
    $("#settingsCancelClose").show();
    $("#settings").show();
    $(".newpaymentitems").show();

    var languageId = 2;
    $("#language").val(2);

    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM ChosenLanguage", [], function (tx, results) {
            if (results.rows.length > 0) {
                languageId = results.rows.item(0).LanguageID;
                $("#language").val(languageId);
            }
        });
    });
}

function settingsOK() {
    var languageId = parseInt($("#language").val());

    db.transaction(function (tx) {
        tx.executeSql(
            "SELECT * FROM Language WHERE LanguageID = " + languageId,
            [],
            function (tx, results) {
                if (results.rows.length > 0) {
                    lang = results.rows.item(0).Ticker;
                    state = results.rows.item(0).State;
                }
            }
        );
    });

    db.transaction(function (tx) {
        tx.executeSql("SELECT * FROM ChosenLanguage", [], function (tx, results) {
            if (results.rows.length == 0) {
                tx.executeSql(
                    "INSERT INTO ChosenLanguage VALUES (" + languageId + ")",
                    [],
                    settingsCallback(languageId)
                );
            } else {
                tx.executeSql(
                    "UPDATE ChosenLanguage SET LanguageID = " + languageId,
                    [],
                    settingsCallback(languageId)
                );
            }
        });
    });
}

function settingsCallback(languageId) {
    $(".maincontainer").show();
    $("#settings").hide();
    //$(".titleText").html(translate("glavni-izbornik"));

    langId = languageId;

    updateLanguage();
    if (loggedIn) {
        updateServerLanguage();
    }
    GetUserAgreement(languageId);

    RateThisAppConfig();

    $("#settingsCancelClose").show();
    $("#firstSettingsOK").hide();
    $("#settingsOK").show();
    console.log(CurrentView);
    switch (CurrentView) {
        case "home.html":
            $(".titleText").html(translate("glavni-izbornik"));
            break;
        case "historynotif.html":
            $(".titleText").html(translate("notifikacije"));
            break;
        case "history.html":
            $(".titleText").html(translate("placanja"));
            break;
        case "templates.html":
            $(".titleText").html(translate("predlosci"));
            $(".obrisiT").html(
                '<img src="Images/Delete.png" class="templateItem"><br>' +
                translate("obrisi")
            );
            $(".plati-parkiranjeT").html(
                '<img src="Images/Submit.png" class="templateItem"><br>' +
                translate("plati-parkiranje")
            );
            break;
        case "cardInformation.html":
            ShowCardInformation();
            break;
        case "addcard.html":
            $(".titleText").html(translate("kartica"));
            break;
        case "details.html":
            $(".titleText").html(translate("transakcija"));
            if (selectedTransactionID != null) {
                LoadTransaction(selectedTransactionID);
            }
            break;
        case "addvehicle.html":
            $(".titleText").html(translate("vozila"));
            break;
        case "newpayment.html":
            $(".titleText").html(translate("placanje"));
            $($("#ddlGradovi").children()[0]).html(translate("odaberite-grad"));
            if (paymentStep == 1) {
                $(".newpaymentStep1").hide();
                $(".newpaymentStep2").show();
                $(".newpaymentitems").hide();
                $(".newpaymentpin").show();
                $("footer").css("height", "auto");
                $("#wrapper")
                    .css("margin-bottom", "-203px")
                    .css("padding-bottom", "203px");
            }
            break;
        default:
            $(".titleText").html(translate("glavni-izbornik"));
            break;
    }
}

function updateServerLanguage() {
    $.ajax({
        url: serviceURL + "/api/MobileApi/UpdateSettings",
        type: "POST",
        data: { UserDeviceGuid: userDeviceGuid, LanguageID: langId },
        success: function (results) {
            if (results.Status == 1) {
                LoadInitialInformationNew(4);
            }
        },
        error: ajaxError,
        timeout: timeout
    });
}

function menuToggle() {
    if ($(".navMenuOverlay").css("visibility") == "hidden") {
        $(".navMenu").addClass("menuShow");
        $(".navMenuOverlay").css("visibility", "visible");
    } else {
        $(".navMenu").removeClass("menuShow");
        $(".navMenuOverlay").css("visibility", "hidden");
    }
}

function showCSCInfo() {
    alertBox(translate("csc"), null, translate("CSC-title"), translate("ok"));
}

function showReklamacijaInfo() {
    alertBox(
        translate("broj-transakcije"),
        null,
        translate("Broj za reklamaciju"),
        translate("ok")
    );
}
